// -------------------------------------------------------------------------------
// 
// 		cwCu		`vOwb_t@C
// 
// 				Ver 3.11d
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICS_H__
#define __DXGRAPHICS_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxGraphicsBase.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxHandle.h"
#include "DxMemImg.h"
#include "DxGraphicsAPI.h"
#include "DxArchive_.h"
#include <stdarg.h>

#if !defined( __ANDROID )
#include "Windows/DxGraphicsWin.h"
#endif

namespace DxLib
{

// }N` --------------------------------------------------------------------

#define GRA2						GraphicsManage2
#define GRH							GraphicsManage2.Hard
#define GRS							GraphicsManage2.Soft

// yobt@tH[}bg
#define ZBUFFER_FORMAT_16BIT		(0)
#define ZBUFFER_FORMAT_24BIT		(1)
#define ZBUFFER_FORMAT_32BIT		(2)
#define ZBUFFER_FORMAT_NUM			(3)

// DrawPreparation ֐ɓntO
#define DRAWPREP_TRANS				(0x00001)
#define DRAWPREP_VECTORINT			(0x00002)
#define DRAWPREP_GOURAUDSHADE		(0x00008)
#define DRAWPREP_PERSPECTIVE		(0x00010)
#define DRAWPREP_DIFFUSERGB			(0x00020)
#define DRAWPREP_DIFFUSEALPHA		(0x00040)
#define DRAWPREP_FOG				(0x00080)
#define DRAWPREP_NOBLENDSETTING		(0x00100)
#define DRAWPREP_LIGHTING			(0x00200)
#define DRAWPREP_SPECULAR			(0x00400)
#define DRAWPREP_3D					(0x00800)
#define DRAWPREP_TEXADDRESS			(0x01000)
#define DRAWPREP_NOTSHADERRESET		(0x02000)
#define DRAWPREP_CULLING			(0x04000)
#define DRAWPREP_TEXALPHACH			(0x08000)
#define DRAWPREP_TEXALPHATEST		(0x10000)
#define DRAWPREP_EDGEFONT			(0x20000)

// _^Cv
#define VERTEXTYPE_NOTEX			(0)				// eNX`gpȂ
#define VERTEXTYPE_TEX				(1)				// eNX`gp
#define VERTEXTYPE_BLENDTEX			(2)				// uheNX`gp
#define VERTEXTYPE_NUM				(3)

// }XN^
#ifdef DX_NON_MASK
#define MASK_FULLSCREEN_MASKUPDATE
#else
#define MASK_FULLSCREEN_MASKUPDATE					\
	if( MASKD.FullScreenMaskUpdateFlag )			\
	{												\
		RECT MaskRect ;								\
		MaskRect.left   = GBASE.DrawArea.left ;		\
		MaskRect.right  = GBASE.DrawArea.right ;	\
		MaskRect.top    = GBASE.DrawArea.top ;		\
		MaskRect.bottom = GBASE.DrawArea.bottom ;	\
		MASK_END( MaskRect )						\
		MASKD.FullScreenMaskUpdateFlag = FALSE ;	\
	}
#endif

// `͈͂ɓĂ邩ǂ̔( 0 `̈ɓĂȂ )
#define IN_DRAWAREA_CHECK( x1, y1, x2, y2 )	\
		( (DWORD)( ( (x2) - ( GBASE.DrawArea.right  + 1 ) ) & ( GBASE.DrawArea.left - ( (x1) + 1 ) ) &					\
		           ( (y2) - ( GBASE.DrawArea.bottom + 1 ) ) & ( GBASE.DrawArea.top  - ( (y1) + 1 ) ) ) & 0x80000000 )

// `͈͂犮SɊOĂ邩ǂ̔( 0 Ȃ犮Sɂ͂Ă )
#define OUT_DRAWAREA_CHECK( x1, y1, x2, y2 ) \
		( (DWORD)( ( GBASE.DrawArea.right  - ( (x1) + 1 ) ) & ( (x2) - ( GBASE.DrawArea.left + 1 ) ) &		\
		           ( GBASE.DrawArea.bottom - ( (y1) + 1 ) ) & ( (y2) - ( GBASE.DrawArea.top  + 1 ) ) ) & 0x80000000 )

#define DRAWRECT_DRAWAREA_CLIP\
		if( IN_DRAWAREA_CHECK( GRH.DrawRect.left, GRH.DrawRect.top, GRH.DrawRect.right, GRH.DrawRect.bottom ) == 0 )\
		{\
			if( GRH.DrawRect.left   < GBASE.DrawArea.left   ) GRH.DrawRect.left   = GBASE.DrawArea.left   ;\
			if( GRH.DrawRect.right  < GBASE.DrawArea.left   ) GRH.DrawRect.right  = GBASE.DrawArea.left   ;\
			if( GRH.DrawRect.left   > GBASE.DrawArea.right  ) GRH.DrawRect.left   = GBASE.DrawArea.right  ;\
			if( GRH.DrawRect.right  > GBASE.DrawArea.right  ) GRH.DrawRect.right  = GBASE.DrawArea.right  ;\
			if( GRH.DrawRect.top    < GBASE.DrawArea.top    ) GRH.DrawRect.top    = GBASE.DrawArea.top    ;\
			if( GRH.DrawRect.bottom < GBASE.DrawArea.top    ) GRH.DrawRect.bottom = GBASE.DrawArea.top    ;\
			if( GRH.DrawRect.top    > GBASE.DrawArea.bottom ) GRH.DrawRect.top    = GBASE.DrawArea.bottom ;\
			if( GRH.DrawRect.bottom > GBASE.DrawArea.bottom ) GRH.DrawRect.bottom = GBASE.DrawArea.bottom ;\
		}

#ifdef DX_NON_MASK
#define MASK_BEGIN( RECT )
#else
#define MASK_BEGIN( RECT )		if( MASKD.MaskValidFlag ) MaskDrawBeginFunction( (RECT) ) ;
#endif

#ifdef DX_NON_MASK
#define MASK_END( RECT )
#else
#define MASK_END( RECT )		if( MASKD.MaskValidFlag ) MaskDrawAfterFunction( (RECT) ) ;
#endif

// `^
#ifdef DX_NON_2DDRAW
	#ifdef DX_NON_MASK
		#define DRAW_DEF( FUNC3D, FUNC2D, SETRECT, RET, USE3DFLAG )\
			{\
				RECT Rect ;\
				if( ( GBASE.BlendMode == DX_BLENDMODE_SUB && GRH.ValidDestBlendOp == FALSE ) || GBASE.AlphaChDrawMode )\
				{\
					SETRECT\
					Rect = GRH.DrawRect ;\
				}\
				if( GBASE.BlendMode == DX_BLENDMODE_SUB && GRH.ValidDestBlendOp == FALSE )\
				{\
					BlendModeSub_Pre( &Rect ) ;\
					RET = (FUNC3D) ;\
					BlendModeSub_Post( &Rect ) ;\
				}\
				else\
				{\
					RET = (FUNC3D) ;\
				}\
			}
	#else // DX_NON_MASK
		#define DRAW_DEF( FUNC3D, FUNC2D, SETRECT, RET, USE3DFLAG )\
			{\
				RECT Rect ;\
				bool UseSubMode = GBASE.BlendMode == DX_BLENDMODE_SUB && GRH.ValidDestBlendOp == FALSE ;\
				if( GBASE.AlphaChDrawMode || UseSubMode || MASKD.MaskValidFlag )\
				{\
					SETRECT\
					Rect = GRH.DrawRect ;\
				}\
				if( UseSubMode || MASKD.MaskValidFlag )\
				{\
					MASK_BEGIN( Rect ) ;\
					if( UseSubMode )\
					{\
						BlendModeSub_Pre( &Rect ) ;\
						RET = (FUNC3D) ;\
						BlendModeSub_Post( &Rect ) ;\
					}\
					else\
					{\
						RET = (FUNC3D) ;\
					}\
					\
					MASK_END( Rect ) ;\
				}\
				else\
				{\
					RET = (FUNC3D) ;\
				}\
			}
	#endif // DX_NON_MASK
#else // DX_NON_2DDRAW
	#ifdef DX_NON_MASK
		#define DRAW_DEF( FUNC3D, FUNC2D, SETRECT, RET, USE3DFLAG )\
			{\
				RECT Rect ;\
				if( ( GBASE.BlendMode == DX_BLENDMODE_SUB && GRH.ValidDestBlendOp == FALSE && (USE3DFLAG) ) || GBASE.AlphaChDrawMode )\
				{\
					SETRECT\
					Rect = GRH.DrawRect ;\
				}\
				if( GBASE.BlendMode == DX_BLENDMODE_SUB && GRH.ValidDestBlendOp == FALSE && (USE3DFLAG) )\
				{\
					BlendModeSub_Pre( &Rect ) ;\
					RET = (FUNC3D) ;\
					BlendModeSub_Post( &Rect ) ;\
				}\
				else\
				{\
					RET = (USE3DFLAG) ? (FUNC3D) : (FUNC2D) ;\
				}\
			}
	#else // DX_NON_MASK
		#define DRAW_DEF( FUNC3D, FUNC2D, SETRECT, RET, USE3DFLAG )\
			{\
				RECT Rect ;\
				bool UseSubMode = GBASE.BlendMode == DX_BLENDMODE_SUB && GRH.ValidDestBlendOp == FALSE && (USE3DFLAG) ;\
				if( GBASE.AlphaChDrawMode || UseSubMode || MASKD.MaskValidFlag )\
				{\
					SETRECT\
					Rect = GRH.DrawRect ;\
				}\
				if( UseSubMode || MASKD.MaskValidFlag )\
				{\
					MASK_BEGIN( Rect ) ;\
					if( UseSubMode )\
					{\
						BlendModeSub_Pre( &Rect ) ;\
						RET = (FUNC3D) ;\
						BlendModeSub_Post( &Rect ) ;\
					}\
					else\
					{\
						RET = (USE3DFLAG) ? (FUNC3D) : (FUNC2D) ;\
					}\
					\
					MASK_END( Rect ) ;\
				}\
				else\
				{\
					RET = (USE3DFLAG) ? (FUNC3D) : (FUNC2D) ;\
				}\
			}
	#endif // DX_NON_MASK
#endif // DX_NON_2DDRAW


// _tH[}bg
#define VERTEXFVF_2D_USER			( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_TEX1 )										// gXtH[ςݒ_tH[}bg
#define VERTEXFVF_NOTEX_2D			( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_TEX1 )										// CA{bNX`p_tH[}bg
#define VERTEXFVF_2D				( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_TEX2 )										// gXtH[ςݒ_tH[}bg
#define VERTEXFVF_BLENDTEX_2D		( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_SPECULAR | D_D3DFVF_TEX3 )					// uheNX`tgXtH[ςݒ_tH[}bg
#define VERTEXFVF_SHADER_2D			( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_SPECULAR | D_D3DFVF_TEX2 )					// VF[_[`p_tH[}bg
#define VERTEXFVF_NOTEX_3D			( D_D3DFVF_XYZ | D_D3DFVF_DIFFUSE /*| D_D3DFVF_SPECULAR*/ )									// CA{bNX`p_tH[}bgARcp( o[Wp )
#define VERTEXFVF_3D				( D_D3DFVF_XYZ | D_D3DFVF_DIFFUSE /*| D_D3DFVF_SPECULAR*/ | D_D3DFVF_TEX1 )					// OtBbNX`p_tH[}bgARcp( o[Wp )
#define VERTEXFVF_3D_LIGHT			( D_D3DFVF_XYZ | D_D3DFVF_NORMAL | D_D3DFVF_DIFFUSE | D_D3DFVF_SPECULAR | D_D3DFVF_TEX2 )	// OtBbNX`p_tH[}bg
#define VERTEXFVF_SHADER_3D			( D_D3DFVF_XYZ | D_D3DFVF_NORMAL | D_D3DFVF_DIFFUSE | D_D3DFVF_SPECULAR | D_D3DFVF_TEX2 )	// VF[_[`p_tH[}bg

// _obt@̃TCY
#define D3DDEV_NOTEX_VERTBUFFERSIZE		(63 * 1024)		// 63KB
#define D3DDEV_TEX_VERTBUFFERSIZE		(64 * 1024)		// 64KB
#define D3DDEV_BLENDTEX_VERTBUFFERSIZE	(64 * 1024)		// 64KB
#define D3DDEV_NOTEX_3D_VERTBUFFERSIZE	(64 * 1024)		// 64KB
#define D3DDEV_TEX_3D_VERTBUFFERSIZE	(64 * 1024)		// 64KB
#define D3DDEV_NOTEX_VERTMAXNUM			(D3DDEV_NOTEX_VERTBUFFERSIZE     / sizeof( VERTEX_NOTEX_2D    ))
#define D3DDEV_TEX_VERTMAXNUM			(D3DDEV_TEX_VERTBUFFERSIZE       / sizeof( VERTEX_2D          ))
#define D3DDEV_BLENDTEX_VERTMAXNUM		(D3DDEV_BLENDTEX_VERTBUFFERSIZE  / sizeof( VERTEX_BLENDTEX_2D ))
#define D3DDEV_NOTEX_3D_VERTMAXNUM		(D3DDEV_NOTEX_3D_VERTBUFFERSIZE  / sizeof( VERTEX_NOTEX_3D    ))
#define D3DDEV_TEX_3D_VERTMAXNUM		(D3DDEV_TEX_3D_VERTBUFFERSIZE    / sizeof( VERTEX_3D          ))

// _CfbNXobt@̃TCY
#define D3DDEV_INDEX_NUM			( D3DDEV_NOTEX_VERTMAXNUM / 4 * 6 )

// tB^[^Cv`
#define DX_D3DTEXF_NONE				D_D3DTEXF_NONE
#define DX_D3DTEXF_POINT			D_D3DTEXF_POINT
#define DX_D3DTEXF_LINEAR			D_D3DTEXF_LINEAR
#define DX_D3DTEXF_ANISOTROPIC		D_D3DTEXF_ANISOTROPIC
#define DX_D3DTEXF_PYRAMIDALQUAD	D_D3DTEXF_PYRAMIDALQUAD
#define DX_D3DTEXF_GAUSSIANQUAD		D_D3DTEXF_GAUSSIANQUAD

// tB^[^[Qbg`
#define DX_D3DSAMP_MAGFILTER		D_D3DTSS_MAGFILTER
#define DX_D3DSAMP_MINFILTER		D_D3DTSS_MINFILTER
#define DX_D3DSAMP_MIPFILTER		D_D3DTSS_MIPFILTER

// VF[_[萔Zbg
#define DX_SHADERCONSTANTSET_LIB		0
#define DX_SHADERCONSTANTSET_LIB_SUB	1
#define DX_SHADERCONSTANTSET_MV1		2
#define DX_SHADERCONSTANTSET_USER		3
#define DX_SHADERCONSTANTSET_NUM		4

// VF[_[萔Zbg}XN
#define DX_SHADERCONSTANTSET_MASK_LIB		0x0001
#define DX_SHADERCONSTANTSET_MASK_LIB_SUB	0x0002
#define DX_SHADERCONSTANTSET_MASK_MV1		0x0004
#define DX_SHADERCONSTANTSET_MASK_USER		0x0008

// VF[_[萔^Cv
#define DX_SHADERCONSTANTTYPE_VS_FLOAT		0
#define DX_SHADERCONSTANTTYPE_VS_INT		1
#define DX_SHADERCONSTANTTYPE_VS_BOOL		2
#define DX_SHADERCONSTANTTYPE_PS_FLOAT		3
#define DX_SHADERCONSTANTTYPE_PS_INT		4
#define DX_SHADERCONSTANTTYPE_PS_BOOL		5
#define DX_SHADERCONSTANTTYPE_NUM			6

// sNZPʃCeBO^Cv̒_VF[_[ʃR[h쐬p}N
#define PIXELLIGHTING_VERTEXSHADER_SHADOWMAP( use )			( ( use )  * 3 * 2 * 4 )
#define PIXELLIGHTING_VERTEXSHADER_SKINMESH( use )			( ( use )  * 2 * 4 )
#define PIXELLIGHTING_VERTEXSHADER_BUMPMAP( use )			( ( use )  * 4 )
#define PIXELLIGHTING_VERTEXSHADER_FOGMODE( mode )			( ( mode ) )

// sNZPʃCeBO^Cv̒_VF[_[ʃR[hevf擾邽߂̃}N
#define PIXELLIGHTING_VERTEXSHADER_GET_SHADOWMAP( index )	( ( index ) / ( 3 * 2 * 4 ) % 2 )
#define PIXELLIGHTING_VERTEXSHADER_GET_SKINMESH( index )	( ( index ) / ( 2 * 4 ) % 3 )
#define PIXELLIGHTING_VERTEXSHADER_GET_BUMPMAP( index )		( ( index ) / ( 4 ) % 2 )
#define PIXELLIGHTING_VERTEXSHADER_GET_FOGMODE( index )		( ( index ) % 4 )

// sNZPʃCeBO^CṽsNZVF[_[^Cv
#define PIXELLIGHTING_PIXELSHADER_TYPE_NORMAL				0	
#define PIXELLIGHTING_PIXELSHADER_TYPE_TOON					1

// sNZPʃCeBO^CṽsNZVF[_[ʃR[h쐬p}N
#define PIXELLIGHTING_PIXELSHADER_TYPE( type )				( ( type  ) * 2 * 5 * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_SHADOWMAP( use )			( ( use   ) * 5 * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_MULTITEX( type )			( ( type  ) * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_TOONTYPE( type )			( ( type  ) * 3 * 2 * 2 * 2 * 2 * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_TOONSPHEREOP( type )		( ( type  ) * 2 * 2 * 2 * 2 * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_TOONDIFBLDOP( type )		( ( type  ) * 2 * 2 * 2 * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_TOONSPCBLDOP( type )		( ( type  ) * 2 * 2 * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_SPECULARMAP( use )		( ( use   ) * 2 * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_BUMPMAP( use )			( ( use   ) * 84 * 2 )
#define PIXELLIGHTING_PIXELSHADER_LIGHTINDEX( index )		( ( index ) * 2 )
#define PIXELLIGHTING_PIXELSHADER_SPECULAR( use )			( ( use   ) )

// sNZPʃCeBO^CṽsNZVF[_[ʃR[hevf擾邽߂̃}N
#define PIXELLIGHTING_PIXELSHADER_GET_TYPE( index )			( ( index ) / ( 2 * 5 * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 ) % 2 )
#define PIXELLIGHTING_PIXELSHADER_GET_SHADOWMAP( index )	( ( index ) / ( 5 * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 ) % 2 )
#define PIXELLIGHTING_PIXELSHADER_GET_MULTITEX( index )		( ( index ) / ( 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 ) % 5 )
#define PIXELLIGHTING_PIXELSHADER_GET_TOONTYPE( index )		( ( index ) / ( 3 * 2 * 2 * 2 * 2 * 84 * 2 ) % 2 )
#define PIXELLIGHTING_PIXELSHADER_GET_TOONSPHEREOP( index )	( ( index ) / ( 2 * 2 * 2 * 2 * 84 * 2 ) % 3 )
#define PIXELLIGHTING_PIXELSHADER_GET_TOONDIFBLDOP( index )	( ( index ) / ( 2 * 2 * 2 * 84 * 2 ) % 2 )
#define PIXELLIGHTING_PIXELSHADER_GET_TOONSPCBLDOP( index )	( ( index ) / ( 2 * 2 * 84 * 2 ) % 2 )
#define PIXELLIGHTING_PIXELSHADER_GET_SPECULARMAP( index )	( ( index ) / ( 2 * 84 * 2 ) % 2 )
#define PIXELLIGHTING_PIXELSHADER_GET_BUMPMAP( index )		( ( index ) / ( 84 * 2 ) % 2 )
#define PIXELLIGHTING_PIXELSHADER_GET_LIGHTINDEX( index )	( ( index ) / ( 2 ) % 84 )
#define PIXELLIGHTING_PIXELSHADER_GET_SPECULAR( index )		( ( index ) % 2 )





// _VF[_[^Cv
#define VERTEXSHADER_TYPE_NORMAL					0
#define VERTEXSHADER_TYPE_DRAW_SHADOWMAP			1
#define VERTEXSHADER_TYPE_TOON_OUTLINE				2

// _VF[_[ʃR[h쐬p}N
#define VERTEXSHADER_TYPE( type )					( ( type  ) * 2 * 2 * 3 * 2 * 4 * 20 * 2 )
#define VERTEXSHADER_SHADERMODEL( ver )				( ( ver   ) * 2 * 3 * 2 * 4 * 20 * 2 )
#define VERTEXSHADER_SHADOWMAP( use )				( ( use   ) * 3 * 2 * 4 * 20 * 2 )
#define VERTEXSHADER_MESHTYPE( type )				( ( type  ) * 2 * 4 * 20 * 2 )
#define VERTEXSHADER_BUMPMAP( use )					( ( use   ) * 4 * 20 * 2 )
#define VERTEXSHADER_FOGMODE( mode )				( ( mode  ) * 20 * 2 )
#define VERTEXSHADER_LIGHTINDEX( index )			( ( index ) * 2 )
#define VERTEXSHADER_SPECULAR( use )				( ( use   ) )

// _VF[_[ʃR[hevf擾邽߂̃}N
#define VERTEXSHADER_GET_TYPE( index )				( ( index ) / ( 2 * 2 * 3 * 2 * 4 * 20 * 2 ) % 3 )
#define VERTEXSHADER_GET_SHADERMODEL( index )		( ( index ) / ( 2 * 3 * 2 * 4 * 20 * 2 ) % 2 )
#define VERTEXSHADER_GET_SHADOWMAP( index )			( ( index ) / ( 3 * 2 * 4 * 20 * 2 ) % 2 )
#define VERTEXSHADER_GET_MESHTYPE( index )			( ( index ) / ( 2 * 4 * 20 * 2 ) % 3 )
#define VERTEXSHADER_GET_BUMPMAP( index )			( ( index ) / ( 4 * 20 * 2 ) % 2 )
#define VERTEXSHADER_GET_FOGMODE( index )			( ( index ) / ( 20 * 2 ) % 4 )
#define VERTEXSHADER_GET_LIGHTINDEX( index )		( ( index ) / ( 2 ) % 20 )
#define VERTEXSHADER_GET_SPECULAR( index )			( ( index ) % 2 )

// sNZVF[_[^Cv
#define PIXELSHADER_TYPE_NORMAL						0
#define PIXELSHADER_TYPE_DRAW_SHADOWMAP				1
#define PIXELSHADER_TYPE_TOON_OUTLINE				2

// sNZVF[_[ʃR[h쐬p}N
#define PIXELSHADER_TYPE( type )					( ( type  ) * 2 * 2 * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define PIXELSHADER_SHADERMODEL( ver )				( ( ver   ) * 2 * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define PIXELSHADER_SHADOWMAP( use )				( ( use   ) * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define PIXELSHADER_MULTITEX( type )				( ( type  ) * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define PIXELSHADER_TOON( use )						( ( use   ) * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define PIXELSHADER_TOONTYPE( type )				( ( type  ) * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define PIXELSHADER_TOONSPHEREOP( type )			( ( type  ) * 2 * 2 * 2 * 2 * 10 * 2 )
#define PIXELSHADER_TOONDIFBLDOP( type )			( ( type  ) * 2 * 2 * 2 * 10 * 2 )
#define PIXELSHADER_TOONSPCBLDOP( type )			( ( type  ) * 2 * 2 * 10 * 2 )
#define PIXELSHADER_SPECULARMAP( use )				( ( use   ) * 2 * 10 * 2 )
#define PIXELSHADER_BUMPMAP( use )					( ( use   ) * 10 * 2 )
#define PIXELSHADER_LIGHTINDEX( index )				( ( index ) * 2 )
#define PIXELSHADER_SPECULAR( use )					( ( use ) )

// sNZVF[_[ʃR[hevf擾邽߂̃}N
#define PIXELSHADER_GET_TYPE( index )				( ( index ) / ( 2 * 2 * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 3 )
#define PIXELSHADER_GET_SHADERMODEL( index )		( ( index ) / ( 2 * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 2 )
#define PIXELSHADER_GET_SHADOWMAP( index )			( ( index ) / ( 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 2 )
#define PIXELSHADER_GET_MULTITEX( index )			( ( index ) / ( 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 5 )
#define PIXELSHADER_GET_TOON( index )				( ( index ) / ( 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 2 )
#define PIXELSHADER_GET_TOONTYPE( index )			( ( index ) / ( 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 2 )
#define PIXELSHADER_GET_TOONSPHEREOP( index )		( ( index ) / ( 2 * 2 * 2 * 2 * 10 * 2 ) % 3 )
#define PIXELSHADER_GET_TOONDIFBLDOP( index )		( ( index ) / ( 2 * 2 * 2 * 10 * 2 ) % 2 )
#define PIXELSHADER_GET_TOONSPCBLDOP( index )		( ( index ) / ( 2 * 2 * 10 * 2 ) % 2 )
#define PIXELSHADER_GET_SPECULARMAP( index )		( ( index ) / ( 2 * 10 * 2 ) % 2 )
#define PIXELSHADER_GET_BUMPMAP( index )			( ( index ) / ( 10 * 2 ) % 2 )
#define PIXELSHADER_GET_LIGHTINDEX( index )			( ( index ) / ( 2 ) % 10 )
#define PIXELSHADER_GET_SPECULAR( index )			( ( index ) % 2 )

/*
// _VF[_[zCfbNX쐬p}N
#define VS_MULTITEX( use )					( ( use )  * 2 * 2 * 3 * 2 * 2 * 4 * 20 * 2 )
#define VS_TOONOUTLINE( use )				( ( use )  * 2 * 3 * 2 * 2 * 4 * 20 * 2 )
#define VS_LIGHTUSE( use )					( ( use )  * 3 * 2 * 2 * 4 * 20 * 2 )
#define VS_SKINMESH( use )					( ( use )  * 2 * 2 * 4 * 20 * 2 )
#define VS_PHONG( use )						( ( use )  * 2 * 4 * 20 * 2 )
#define VS_BUMPMAP( use )					( ( use )  * 4 * 20 * 2 )
#define VS_FOGMODE( mode )					( ( mode ) * 20 * 2 )
#define VS_LIGHTINDEX( type )				( ( type ) * 2 )
#define VS_SPECULAR( use )					( ( use ) )

// _VF[_[zCfbNXevf擾邽߂̃}N
#define VS_GET_MULTITEX( index )			( ( index ) / ( 2 * 2 * 3 * 2 * 2 * 4 * 20 * 2 ) % 2 )
#define VS_GET_TOONOUTLINE( index )			( ( index ) / ( 2 * 3 * 2 * 2 * 4 * 20 * 2 ) % 2 )
#define VS_GET_LIGHTUSE( index )			( ( index ) / ( 3 * 2 * 2 * 4 * 20 * 2 ) % 2 )
#define VS_GET_SKINMESH( index )			( ( index ) / ( 2 * 2 * 4 * 20 * 2 ) % 3 )
#define VS_GET_PHONG( index )				( ( index ) / ( 2 * 4 * 20 * 2 ) % 2 )
#define VS_GET_BUMPMAP( index )				( ( index ) / ( 4 * 20 * 2 ) % 2 )
#define VS_GET_FOGMODE( index )				( ( index ) / ( 20 * 2 ) % 4 )
#define VS_GET_LIGHTINDEX( index )			( ( index ) / ( 2 ) % 20 )
#define VS_GET_SPECULAR( index )			( ( index ) % 2 )

// sNZVF[_[zCfbNX쐬p}N
#define PS_MULTITEX( use )					( ( use )  * 3 * 3 * 2 * 2 * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 )
#define PS_TOON( use )						( ( use )  * 3 * 2 * 2 * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 )
#define PS_TOONSPHEREOP( type )				( ( type ) * 2 * 2 * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 )
#define PS_TOONDIFBLDOP( type )				( ( type ) * 2 * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 )
#define PS_TOONSPCBLDOP( type )				( ( type ) * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 )
#define PS_LIGHTUSE( use )					( ( use )  * 2 * 2 * 2 * 3 * 3 * 3 * 2 )
#define PS_SPECULARMAP( use )				( ( use )  * 2 * 2 * 3 * 3 * 3 * 2 )
#define PS_PHONG( use )						( ( use )  * 2 * 3 * 3 * 3 * 2 )
#define PS_BUMPMAP( use )					( ( use )  * 3 * 3 * 3 * 2 )
#define PS_LIGHT0TYPE( type )				( ( type ) * 3 * 3 * 2 )
#define PS_LIGHT1TYPE( type )				( ( type ) * 3 * 2 )
#define PS_LIGHT2TYPE( type )				( ( type ) * 2 )
#define PS_SPECULAR( use )					( ( use ) )

// sNZVF[_[zCfbNXevf擾邽߂̃}N
#define PS_GET_MULTITEX( index )			( ( index ) / ( 3 * 3 * 2 * 2 * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 ) % 5 )
#define PS_GET_TOON( index )				( ( index ) / ( 3 * 2 * 2 * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 ) % 3 )
#define PS_GET_TOONSPHEREOP( index )		( ( index ) / ( 2 * 2 * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 ) % 3 )
#define PS_GET_TOONDIFBLDOP( index )		( ( index ) / ( 2 * 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 ) % 2 )
#define PS_GET_TOONSPCBLDOP( index )		( ( index ) / ( 2 * 2 * 2 * 2 * 3 * 3 * 3 * 2 ) % 2 )
#define PS_GET_LIGHTUSE( index )			( ( index ) / ( 2 * 2 * 2 * 3 * 3 * 3 * 2 ) % 2 )
#define PS_GET_SPECULARMAP( index )			( ( index ) / ( 2 * 2 * 3 * 3 * 3 * 2 ) % 2 )
#define PS_GET_PHONG( index )				( ( index ) / ( 2 * 3 * 3 * 3 * 2 ) % 2 )
#define PS_GET_BUMPMAP( index )				( ( index ) / ( 3 * 3 * 3 * 2 ) % 2 )
#define PS_GET_LIGHT0TYPE( index )			( ( index ) / ( 3 * 3 * 2 ) % 3 )
#define PS_GET_LIGHT1TYPE( index )			( ( index ) / ( 3 * 2 ) % 3 )
#define PS_GET_LIGHT2TYPE( index )			( ( index ) / ( 2 ) % 3 )
#define PS_GET_SPECULAR( index )			( ( index ) % 2 )
*/

// tB^[^Cv`
#define DX_D3DTEXFILTER_TYPE		D_D3DTEXTUREFILTERTYPE

// ef[^ւ̃ANZXLqȗp}N
#define GSYSTEM						DX_GraphicsSystemData

// foCX񋓂̍ő吔
#define MAX_DEVICE_LISTUP					(32)

// ǗeNX`ւ̃f[^]pVXezueNX`̐
#define SYSMEMTEXTURE_NUM					(2048)

// Lobt@̐
#define COMMON_BUFFER_NUM					(3)


// \̒` --------------------------------------------------------------------

// _^F\
struct COLOR
{
	float					r, g, b, a ;
} ;

// Qc`p_\(eNX`)
typedef struct tagVERTEX_NOTEX_2D
{
	VECTOR					pos ;
	float					rhw ;
	int						color ;
	float					sc_u, sc_v ;
} VERTEX_NOTEX_2D, *LPVERTEX_NOTEX_2D ; 

// ɂQc`Ɏgp钸_f[^^
typedef struct tagVERTEX_2D
{
	VECTOR					pos ;
	float					rhw ;
	int						color ;
	float					u, v ;
	float					sc_u, sc_v ;
} VERTEX_2D, *LPVERTEX_2D ; 

// uh摜tQc摜`p_\
struct VERTEX_BLENDTEX_2D
{
	VECTOR					pos ;
	float					rhw ;
	int						color ;
	unsigned int			specular ;
	float					u1, v1 ;
	float					u2, v2 ;
	float					sc_u, sc_v ;
} ;

// }eA\
struct MATERIAL
{
	COLOR					Diffuse ;		// fBt[YF
	COLOR					Ambient ;		// ArGgF
	COLOR					Specular ;		// XyL[F
	COLOR					Emissive ;		// G~bVF
	float					Power ;			// p[
} ;

// Cg\
struct LIGHT
{
	int						Type ;
	COLOR					Diffuse ;
	COLOR					Specular ;
	COLOR					Ambient ;
	VECTOR					Position ;
	VECTOR					Direction ;
	float					Range ;
	float					Falloff ;
	float					Attenuation0 ;
	float					Attenuation1 ;
	float					Attenuation2 ;
	float					Theta ;
	float					Phi ;
} ;


// eNX`Xe[W̏
struct DIRECT3DTEXTURESTAGEINFO
{
	void					*Texture ;							// Xe[WɃZbgĂeNX`T[tFX
	int						TextureCoordIndex ;					// gpeNX`WCfbNX
	int						ResultTempARG ;						// o͐惌WX^e|ɂ邩ǂ
	short					AlphaARG1, AlphaARG2, AlphaOP ;		// Direct3DDevice  D3DTSS_ALPHAOP  D3DTSS_ALPHAARG1  D3DTSS_ALPHAARG2 ̐ݒl
	short					ColorARG1, ColorARG2, ColorOP ;		// Direct3DDevice  D3DTSS_COLOROP  D3DTSS_COLORARG1  D3DTSS_COLORARG2 ̐ݒl
} ;

// cRc ̃uhݒɊւݒ̏
struct DIRECT3DBLENDINFO
{
	int						AlphaTestEnable ;					// Direct3DDevice  D3DRENDERSTATE_ALPHATESTENABLE ̐ݒl
	int						AlphaRef ;							// Direct3DDevice  D3DRENDERSTATE_ALPHAREF ̐ݒl
	int						AlphaFunc ;							// Direct3DDevice  D3DRENDERSTATE_ALPHAFUNC ̐ݒl
	int						AlphaBlendEnable ;					// Direct3DDevice  D3DRENDERSTATE_ALPHABLENDENABLE ̐ݒl
	int						SeparateAlphaBlendEnable ;			// Direct3DDevice  D3DRENDERSTATE_SEPARATEALPHABLENDENABLE ̐ݒl

	DWORD					FactorColor ;						// Direct3DDevice  D3DRENDERSTATE_TEXTUREFACTOR ̐ݒl
	int						SrcBlend, DestBlend ;				// Direct3DDevice  D3DRENDERSTATE_DESTBLEND  D3DRENDERSTATE_SRCBLEND ̐ݒl
	int						BlendOp ;							// Direct3DDevice  D3DRENDERSTATE_BLENDOP ̐ݒl
	int						SrcBlendAlpha, DestBlendAlpha ;		// Direct3DDevice  D3DRENDERSTATE_DESTBLENDALPHA  D3DRENDERSTATE_SRCBLENDALPHA ̐ݒl
	int						BlendOpAlpha ;						// Direct3DDevice  D3DRENDERSTATE_BLENDOPALPHA ̐ݒl
	int						UseTextureStageNum ;				// gpĂeNX`Xe[W̐
	DIRECT3DTEXTURESTAGEINFO TextureStageInfo[USE_TEXTURESTAGE_NUM] ;	// Direct3DDevice ̃eNX`Xe[Wݒl( Direct3DDevice ɂꂩK\̐ݒl )
} ;


// \tgEGA_OpIWi摜
struct IMAGEDATA2_ORIG_SOFT
{
	MEMIMG					MemImg ;						// MEMIMG
	MEMIMG					*ZBuffer ;						// ZBuffer
} ;

// ǗeNX`ւ̃f[^]pVXezueNX`̏
struct IMAGEDATA2_SYSMEMTEXTURE
{
	unsigned char			InitializeFlag ;				// gp\ȏԂǂ̃tO
	unsigned char			UseFlag ;						// gpǂ̃tO
	unsigned char			CubeMap ;						// L[u}bvǂ( 1:L[u}bveNX`  0:ʏeNX` )
	unsigned char			MipMapCount ;					// ~bv}bv̐
	short					Width ;							// 
	short					Height ;						// 
	unsigned char			Format ;						// tH[}bg( DX_GRAPHICSIMAGE_FORMAT_3D_RGB16 Ȃ )
	unsigned int			UseCount ;						// gp
	int						UseTime ;						// ŌɎgp
	DX_DIRECT3DBASETEXTURE9	*MemTexture ;					// VXeeNX`
} ;

// n[hEGA_OpIWi摜eNX`
struct IMAGEDATA2_ORIG_HARD_TEX
{
	union
	{
		DX_DIRECT3DCUBETEXTURE9	*CubeTexture ;				// L[ueNX`
		DX_DIRECT3DTEXTURE9		*Texture ;					// eNX`
	} ;
	DX_DIRECT3DTEXTURE9		*MemTexture ;					// D3DPOOL_MANAGED gpłȂ摜peNX`
	DX_DIRECT3DSURFACE9		*Surface[ CUBEMAP_SURFACE_NUM ] ;	// T[tFX
	DX_DIRECT3DSURFACE9		*RenderTargetSurface ;			// _O^[QbgT[tFX
	DX_DIRECT3DSURFACE9		*ZBuffer ;						// yobt@

	int						OrigPosX, OrigPosY ;			// 摜ŎgpĂ̈̍W
	int						UseWidth, UseHeight ;			// 摜ŎgpĂ̈̃TCY
	int						TexWidth, TexHeight ;			// eNX`̂̕ƍ
} ;

// n[hEGA_OpIWi摜
struct IMAGEDATA2_ORIG_HARD
{
	int						MipMapCount ;					// ~bv}bv̐
	int						TexNum ;						// eNX`̐
	IMAGEDATA2_ORIG_HARD_TEX Tex[ 4 ] ;						// eNX`Xgւ̃|C^
} ;

// IWi摜\
struct IMAGEDATA2_ORIG
{
	int						RefCount ;						// QƂĂ鐔
	int						ColorFormat ;					// J[tH[}bg( DX_GRAPHICSIMAGE_FORMAT_3D_RGB16  )
	IMAGEFORMATDESC			FormatDesc ;					// tH[}bg
	unsigned int			TransCode ;						// ߐFR[h
	int						Width, Height ;					// 摜̃TCY
	int						ZBufferFlag ;					// yobt@邩ǂ( TRUE:  FALSE:Ȃ )
	int						ZBufferBitDepthIndex ;			// yobt@rbg[xCfbNX

	union
	{
		IMAGEDATA2_ORIG_SOFT	Soft ;						// \tgEGA_Op
		IMAGEDATA2_ORIG_HARD	Hard ;						// n[hEGA_Op
	} ;
} ;

// \tgEGA_OŃC[Wf[^\
struct IMAGEDATA2_SOFT
{
	MEMIMG					MemImg ;						// `p MEMIMG
} ;

// n[hEGA_OōW\
struct IMAGEDATA2_HARD_VERT
{
	float					x, y ;							// ʒu
	float					u, v ;							// tuʒu
} ;

// n[hEGA_Oŕ`p\
struct IMAGEDATA2_HARD_DRAW
{
	int						DrawPosX, DrawPosY ;			// `掞Ɏw肳W̑΍W
	int						UsePosX, UsePosY ;				// eNX`ŎgpĂ`̍W
	int						Width, Height ;					// eNX`ŎgpĂTCY

	IMAGEDATA2_HARD_VERT	Vertex[ 4 ] ;					// eNX`̕`W
	unsigned char			VertType[ 4 ] ;					// _^Cv( TRUE=Op̔@FALSE= )

	IMAGEDATA2_ORIG_HARD_TEX *Tex ;							// gpeNX`ւ̃|C^
} ;

// n[hEGA_OŃC[Wf[^\
struct IMAGEDATA2_HARD
{
	int						DrawNum ;						// `p̐
	IMAGEDATA2_HARD_DRAW	Draw[ 4 ] ;						// `p
} ;

// C[Wf[^\
struct IMAGEDATA_READBASE
{
	int						Type ;							// ^Cv( 0:t@C 1:C[W 2:BaseImage )

	TCHAR					*FileName ;						// t@C
	BASEIMAGE				*BaseImage ;					// {C[Wf[^
	BASEIMAGE				*AlphaBaseImage ;				// `lp{C[Wf[^
	void					*MemImage ;						// C[W
	int						MemImageSize ;					// C[WTCY
	void					*AlphaMemImage ;				// `lpC[W
	int						AlphaMemImageSize ;				// `lpC[WTCY
	int						ReverseFlag ;					// ]ǂݍ݂ǂ( TRUE:  FALSE:ĂȂ )Aēǂݍ݂̍ۂɓǂݍ݌𔽓]邩ǂŎgpABASEIMAGE ɊւĂ͓ǂݍ݌ۑɔ]邽߂̃tO͖

	int						RefCount ;						// QƐ
} ;

// C[Wf[^\
struct IMAGEDATA2
{
	HANDLEINFO				HandleInfo ;					// nhʃf[^

	int						*LostFlag ;						// ɗĂtÕ|C^

#ifndef DX_NON_MOVIE
	int						MovieHandle ;					// nh
#endif

	IMAGEDATA_READBASE		*ReadBase ;						// f[^
	int						UseBaseX, UseBaseY ;			// f[^ŎgpĂ͈͂̍W

	IMAGEDATA2_ORIG			*Orig ;							// IWi摜\̂ւ̃|C^( IWi摜ł͂Ȃꍇ NULL )
	int						UseOrigX, UseOrigY ;			// IWi摜̎gpĂ`̍W
	int						Width, Height ;					// IWi摜̎gpĂ`̕ƍ

	DWORD					*FullColorImage ;				// tJ[C[W

	int						LockFlag ;						// bNĂ邩ǂtO
	BYTE					*LockImage ;					// bNɍ쐬e|C[W
	DWORD					LockImagePitch ;				// bNC[W̃sb`

	int						DeviceLostDeleteFlag ;			// foCXXgɍ폜邩ǂ̃tO( TRUE:foCXXgɍ폜  FALSE:foCXXgɍ폜Ȃ )

	union
	{
		IMAGEDATA2_SOFT		Soft ;							// \tgEGA_Op\̂ւ̃|C^
		IMAGEDATA2_HARD		Hard ;							// n[hEGA_Op\̂ւ̃|C^
	} ;
} ;

// VF[_[nhŎgp̍\
struct SHADERHANDLEDATA
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	int						IsVertexShader ;					// _VF[_[ǂ( TRUE:_VF[_[  FALSE:sNZVF[_[ )
	void					*FunctionCode ;						// VF[_[쐬ۂɎgpԃR[hi[̈ւ̃|C^
	union
	{
		DX_DIRECT3DPIXELSHADER9		*PixelShader ;				// IDirect3DPixelShader9 ̃|C^
		DX_DIRECT3DVERTEXSHADER9	*VertexShader ;				// IDirect3DVertexShader9 ̃|C^
	} ;
	int						ConstantNum ;						// 萔̐
	D_D3DXSHADER_CONSTANTINFO	*ConstantInfo ;					// 萔z̐擪AhX
} ;

// _obt@nhŎgp̍\
struct VERTEXBUFFERHANDLEDATA
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	int						Type ;								// _f[^̃^Cv( DX_VERTEXTYPE_NORMAL_3D  )
	int						UnitSize ;							// _f[^ӂ̃oCg
	int						Num ;								// _̐
	void					*Buffer ;							// VXeɊmۂꂽobt@
	DX_DIRECT3DVERTEXBUFFER9	*Direct3DBuffer ;				// IDirect3DVertexBuffer9 ̃|C^
} ;

// CfbNXobt@nhŎgp̍\
struct INDEXBUFFERHANDLEDATA
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	int						Type ;								// CfbNXf[^̃^Cv( DX_INDEX_TYPE_NORMAL_3D  )
	int						UnitSize ;							// CfbNXf[^ӂ̃oCg
	int						Num ;								// CfbNX̐
	void					*Buffer ;							// VXeɊmۂꂽobt@
	DX_DIRECT3DINDEXBUFFER9	*Direct3DBuffer ;					// IDirect3DIndexBuffer9 ̃|C^
} ;

#ifndef DX_NON_FILTER

// VF[_[R[hnh
struct SHADERCODE_HANDLE
{
	int						Gauss_PS[ 3 ] ;							// KEXtB^̃sNZVF[_[
	int						BrightClipPS[ 2 ][ 2 ] ;				// 邳ŃNbvtB^̃sNZVF[_[( [ 1:ȏNbv  0:ȉNbv ][ 1:NbvhԂ 0:hԂȂ ] )
	int						DownScalePS[ 3 ] ;						// ktB^[( 0:X2 1:X4 2:X8 )
	int						HsbPS[ 3 ] ;							// gratB^[( 0:RGB to HSI  1:HSI to RGB  2:HSB  HLock )
	int						MonoPS ;								// mg[tB^[
	int						InvertPS ;								// K]tB^[
	int						LevelPS ;								// x␳tB^[
	int						GammaTex ;								// K}␳Ɏgp摜
	float					PrevGamma ;								// ÕK}tB^̍ۂ̃K}l
	int						TwoColorPS ;							// QltB^[
	int						GradientMapPS[ 2 ] ;					// Of[V}bvtB^[
	int						PreMulAlphaPS ;							// ʏ摜Zς݃At@摜쐬ׂ̃tB^[
	int						InterpAlphaPS ;							// Zς݃At@摜ʏ摜쐬ׂ̃tB^[

	int						BasicBlendPS[ 14 ] ;					// {IȃuhtB^[
	int						RgbaMixBasePS ;							// RGBAMixuh{
	int						RgbaMixSRGBB[ 4 ] ;						// RGBAMixuh A  BRGBA ̂S
	int						RgbaMixSRRRB[ 4 ][ 4 ] ;				// RGBAMixuh SYYY BX ̂PU [ Y ][ X ]
	int						RgbaMixS[ 4 ][ 4 ][ 4 ][ 4 ] ;			// RGBAMixuh S ̑gݍ킹256[ R ][ G ][ B ][ A ]
} ;

#endif // DX_NON_FILTER


// VF[_[萔̈̎gp̈\
struct SHADERCONST_ONE_USEAREA
{
	WORD					Start ;									// gp̈̊Jnԍ
	WORD					EndPlusOne ;							// gp̈̏Iԍ{P
} ;

// VF[_[萔gp̈\
struct SHADERCONSTANT_USEAREA
{
	SHADERCONST_ONE_USEAREA	AreaInfo[ 256 ] ;						// gp̈
	int						AreaInfoNum ;							// gp̈̐
	int						TotalSize ;								// Ǘ̈̃TCY
} ;

// VF[_[萔\
struct SHADERCONSTANTINFO
{
	SHADERCONSTANT_USEAREA	UseArea ;								// [U[p_VF[_[萔̎gp̈
	int						UnitSize ;								// f[^̃TCY

	union
	{
		BYTE					Data[ 256 * 16 ] ;					// TCYۏؗpf[^

		FLOAT4					Float4[ 256 ] ;						// [U[p_VF[_[ float ^萔
		INT4					Int4[ 16 ] ;						// [U[p_VF[_[ int ^萔
		BOOL					Bool[ 16 ] ;						// [U[p_VF[_[ BOOL ^萔
	} ;
} ;

// VF[_[萔Zbg\
struct SHADERCONSTANTINFOSET
{
	int						IsApply[ DX_SHADERCONSTANTSET_NUM ] ;			// 萔Kp邩ǂ( TRUE:Kp  FALSE:KpȂ )
	int						ApplyMask ;										// Kp}XN( DX_SHADERCONSTANTSET_MASK_LIB | DX_SHADERCONSTANTSET_MASK_LIB_SUB  )
	SHADERCONSTANTINFO		Info[ DX_SHADERCONSTANTTYPE_NUM ][ DX_SHADERCONSTANTSET_NUM ] ;				// 萔
	BYTE					UseMap[ DX_SHADERCONSTANTTYPE_NUM ][ DX_SHADERCONSTANTSET_NUM ][ 256 ] ;	// 萔gp}bv

	SHADERCONSTANTINFO		FixInfo[ DX_SHADERCONSTANTTYPE_NUM ] ;			// ۂɃVF[_[ɓKpĂ萔

	BYTE					SetMap[ DX_SHADERCONSTANTTYPE_NUM ][ 256 ] ;	// VF[_[萔̎gpZbg}bv( DX_SHADERCONSTANTSET_LIB A0xff gp )
} ;

// [U[̕`ݒ\
struct USERRENDERINFO
{
	int						SetTextureGraphHandle[ 20 ] ;			// [U[ݒ̊eXe[W̃eNX`
	int						SetRenderTargetGraphHandle[ 4 ] ;		// [U[ݒ̊e_O^[Qbg

	int						SetVertexShaderHandle ;					// [U[ݒŎgp钸_VF[_[
	int						SetPixelShaderHandle ;					// [U[ݒŎgpsNZVF[_[
} ;

// VhE}bvf[^\
struct SHADOWMAPDATA
{
	HANDLEINFO				HandleInfo ;					// nhʃf[^

	int						*LostFlag ;						// ɗĂtÕ|C^

	int						TexFormat_Float ;				// _^tH[}bgǂ( TRUE:_^  FALSE:Œ菬_^ )
	int						TexFormat_BitDepth ;			// rbg[x
	int						ColorFormat ;					// J[tH[}bg
	int						ZBufferFormat ;					// yobt@tH[}bg

	int						EnableDrawArea ;				// DrawAreaMinPosition  DrawAreaMaxPosition Lǂ
	VECTOR					DrawAreaMinPosition ;			// VhE}bv̕`̍ۂɓ͈͂̏W
	VECTOR					DrawAreaMaxPosition ;			// VhE}bv̕`̍ۂɓ͈͂̑傫W
	VECTOR					DrawAreaViewClipPos[ 8 ] ;		// VhE}bvɕ`悷͈͂͂ލW

	VECTOR					DefaultViewClipPos[ 8 ] ;		// EnableDrawArea  FALSE ̍ۂɎgpVhE}bvɕ`悷͈͂͂ލW

	int						BaseSizeX ;						// VhE}bṽTCY
	int						BaseSizeY ;

	int						DrawSetupFlag ;					// `揀Ă邩ǂ̃tO

	MATRIX					ShadowMapViewMatrix ;			// VhE}bv`悵ۂ̃r[s
	MATRIX					ShadowMapProjectionMatrix ;		// VhE}bv`悵ۂ̎ˉes

	float					AdjustDepth ;					// VhE}bvgp`掞̐[x␳l
	int						BlurParam ;						// VhE}bvɓKpڂtB^[̒l
	float					GradationParam ;				// VhE}bvl̃Of[V͈̔

	int						RenderTargetScreen[ DX_RENDERTARGET_COUNT ] ;			// X̃_O^[Qbg
	int						RenderTargetScreenSurface[ DX_RENDERTARGET_COUNT ] ;	// X̃_O^[QbgT[tFX

	int						RenderMaskUseFlag ;				// }XNʂgp邩ǂ̃tO

	VECTOR					LightDirection ;				// VhE}bvz肷郉Cg̕
	MATRIX					LightMatrix ;					// VhE}bvz肷郉Cg̍s

	VECTOR					RenderCameraPosition ;			// _Osۂ̃J̈ʒu
	VECTOR					RenderCameraTarget ;			// _Osۂ̃J̒_
	VECTOR					RenderCameraUp ;				// _Osۂ̃J̃AbvxNg
	float					RenderCameraHRotate ;			// _Osۂ̃J̐px
	float					RenderCameraVRotate ;			// _Osۂ̃J̐px
	float					RenderCameraTRotate ;			// _Osۂ̃J̔Ppx
	MATRIX					RenderCameraMatrix ;			// _Osۂ̃r[s
	float					RenderCameraScreenCenterX ;		// _Osۂ̃J̏_
	float					RenderCameraScreenCenterY ;

	int						RenderProjectionMatrixMode ;	// _Osۂ̎ˉes쐬[h
	float					RenderProjNear ;				// _Osۂ̃J NearNbv
	float					RenderProjFar ;					// _Osۂ̃J FarNbv
	float					RenderProjDotAspect ;			// _Osۂ̃hbgAXyNg( c /  )
	float					RenderProjFov ;					// _Osۂ̉ߖ@̎p
	float					RenderProjSize ;				// _Osۂ̐ˉẽTCY
	MATRIX					RenderProjMatrix ;				// _Osۂ̎ˉes

	DX_DIRECT3DTEXTURE9		*Texture ;						// eNX`

	DX_DIRECT3DSURFACE9		*Surface ;						// T[tFX
	DX_DIRECT3DSURFACE9		*ZBufferSurface ;				// yobt@T[tFX
} ;

// n[hEGAANZ[^gpOtBbNXŎgp̍\
struct GRAPHICS_HARDDATA
{
	int						UseDirect3D9Ex ;						// Direct3D9Ex gp邩ǂ
	int						UseMultiThread ;						// }`XbhΉtOgǂ
	int						ValidAdapterNumber ;					// UseAdapterNumber Lǂ( TRUE:L  FALSE: )
	int						UseAdapterNumber ;						// gpfoCXA_v^ԍ
	int						NonUseVertexHardwareProcess ;			// Iɒ_Zn[hEGAŏȂǂ( TRUE:Ȃ  FALSE: )
	int						UsePixelLightingShader ;				// sNZPʂŃCeBOs^CṽVF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )
	int						VertexHardwareProcess ;					// _Zn[hEGAŏ邩ǂ( TRUE:  FALSE:Ȃ )
	int						ValidVertexShader ;						// _VF[_[gp\ǂ( TRUE:gp\  FALSE:s\ )
	int						ValidPixelShader ;						// sNZVF[_[gp\ǂ( TRUE:gp\  FALSE:s\ )
	int						ValidVertexShader_SM3 ;					// Shader Model 3.0 ̒_VF[_[gp\ǂ( TRUE:gp\  FALSE:s\ )
	int						ValidPixelShader_SM3 ;					// Shader Model 3.0 ̃sNZVF[_[gp\ǂ( TRUE:gp\  FALSE:s\ )
	int						DisableAeroFlag ;						// Aero 𖳌ɂ邩ǂ̃tO( TRUE:ɂ  FALSE:ɂȂ )
	DWORD					NativeVertexShaderVersion ;				// G~[V̒_VF[_[̃o[W

	int						UseBaseVertexShaderIndex ;				// gp钸_VF[_[̃CgEtHOEtHVF[fBO̗L̂ݐݒ肵l
	int						UseBasePixelShaderIndex ;				// gpsNZVF[_[̃CgEtHVF[fBO̗L̂ݐݒ肵l
	int						UseBaseVertexShaderIndex_PL ;			// sNZPʃCeBO^CvŎgp钸_VF[_[̃CgEtHOEtHVF[fBO̗L̂ݐݒ肵l
	int						UseBasePixelShaderIndex_PL ;			// sNZPʃCeBO^CvŎgpsNZVF[_[̃CgEtHVF[fBO̗L̂ݐݒ肵l
	int						UseOnlyPixelLightingTypeCode ;			// sNZPʃCeBO^CṽVF[_[R[hgpwɂȂĂ邩ǂ

	D_D3DMULTISAMPLE_TYPE	FSAAMultiSampleType ;					// FSAAp}`TvO^Cv
	int						FSAAMultiSampleQuality ;				// FSAAp}`TvONIeB
	int						MipMapCount ;							// ō쐬~bv}bv̐( -1:ő僌x܂ō쐬 )
	int						FullScreenEmulation320x240 ;			// tXN[[h 320x240 w肳Ă邩ǂ( TRUE:w肳Ă  FALSE:w肳ĂȂ )
	int						UseRenderTargetLock ;					// `T[tFX̃bNsǂ( TRUE:s  FALSE:sȂ )

	int						ValidAdapterInfo ;						// A_v^̏񂪗Lǂ( TRUE:L  FALSE: )
	int						AdapterInfoNum ;						// A_v^̐
	D_D3DADAPTER_IDENTIFIER9	AdapterInfo[ MAX_DEVICE_LISTUP ] ;	// A_v^̏

	D_D3DFORMAT				ScreenFormat ;										// ʃJ[tH[}bg
	D_D3DFORMAT				TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_NUM ] ;	// eNX`tH[}bg
	D_D3DFORMAT				MaskColorFormat ;									// }XNJ[obt@ptH[}bg
	D_D3DFORMAT				MaskAlphaFormat ;									// }XNAt@`lptH[}bg
	D_D3DFORMAT				ZBufferFormat[ ZBUFFER_FORMAT_NUM ] ;				// yobt@tH[}bg

	IMAGEDATA2_SYSMEMTEXTURE SysMemTexture[ SYSMEMTEXTURE_NUM ] ;	// ǗeNX`ւ̃f[^]pVXezueNX`
	int						SysMemTextureInitNum ;					// ς݂̔ǗeNX`̐

	int						UserMaxTextureSize ;					// [U[w̃eNX`őTCY
	int						NotUseDivFlag ;							// 摜sȂǂ( TRUE:sȂ  FALSE:s )
	int						UseOldDrawModiGraphCodeFlag ;			// ȑO DrawModiGraph ֐R[hgp邩ǂ̃tO

	int						FlipRunScanline[ 2 ] ;					// ScreenFlip sƂ̃XLCl
	DWORD					FlipRunTime[ 2 ] ;						// ScreenFlip sƂ timeGetTime ̒l
	int						FlipSkipFlag ;							// FlipXLbvAtO( TRUE:XLbv  FALSE:XLbvł͂Ȃ )

	int						ValidTexTempRegFlag ;					// eNX`Xe[W̃e|WX^gpł邩ǂ̃tO

	DX_DIRECT3DSURFACE9		*BackBufferSurface ;					// foCXobNobt@T[tFX
	DX_DIRECT3DSURFACE9		*SubBackBufferSurface ;					// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\T[tFX
	DX_DIRECT3DSURFACE9		*ZBufferSurface ;						// CŎgpyobt@
	int						ZBufferSizeX, ZBufferSizeY ;			// yobt@T[tFX̃TCY
	int						UserZBufferSizeSet ;					// Oyobt@TCY̎w肪ǂ
	int						ZBufferBitDepth ;						// yobt@T[tFX̃rbg[x
	int						UserZBufferBitDepthSet ;				// yobt@̃rbg[xw肪ǂ

	IMAGEFORMATDESC			*DrawPrepFormat ;						// O DrawPreparation ɓƂ Format p[^
	DX_DIRECT3DTEXTURE9		*DrawPrepTexture ;						// O DrawPreparation ɓƂ Texture p[^
	int						DrawPrepParamFlag ;						// O DrawPreparation ɓƂ ParamFlag p[^
	int						DrawPrepAlwaysFlag ;					// K DrawPreparation sǂ̃tO

	D_D3DCAPS9				DeviceCaps ;							// foCX
	int						TextureSizePow2 ;						// eNX`̃TCYQ̂łKv邩ǂ
	int						TextureSizeNonPow2Conditional ;			// tŃeNX`̃TCYQ̂łȂĂvǂ
	int						MaxTextureSize ;						// őeNX`TCY
	int						ValidDestBlendOp ;						// D3DBLENDOP_ADD ȊOgp\ǂ( TRUE:gp\  FALSE:gps\ )
	int						WhiteTexHandle ;						// 8x8̔eNX`̃nh
	int						MaxPrimitiveCount ;						// xɕ`łv~eBu̍ő吔

	DX_DIRECT3DSURFACE9		*TargetSurface[DX_RENDERTARGET_COUNT] ;	// `Ώۂ̃T[tFX
	int						RenderTargetNum ;						// ɐݒł郌_O^[Qbg̐

	D_D3DVIEWPORT9			Viewport ;								// r[|[g
	RECT					ScissorRect ;							// VU[`
	int						ScissorTestEnable ;						// VU[`̗LA( TRUE:L FALSE: )

	BYTE					*VertexBufferPoint[2][3] ;				// e_obt@ւ̃|C^( [ Rc_ǂ ][ _^Cv ] )
	int						Use3DVertex ;							// Rc_gpĂ邩ǂ( 1:gpĂ  0:gpĂȂ )
	int						VertexNum ; 							// _obt@Ɋi[Ă钸_̐
	int						VertexType ;							// _obt@Ɋi[Ă钸_f[^( 0:eNX`Ȃ  1:eNX`  2:uheNX` )
	D_D3DPRIMITIVETYPE		PrimitiveType ;							// _obt@Ɋi[Ă钸_f[^̃v~eBu^Cv

	float					BlendTextureWidth ;						// uheNX`̕
	float					BlendTextureHeight ;					// uheNX`̍
	float					InvBlendTextureWidth ;					// uheNX`̋̕t
	float					InvBlendTextureHeight ;					// uheNX`̍̋t
	DWORD					DiffuseColor ;							// fBt[YJ[

	int						GaussPass1_VS ;							// KEXtB^VF[_[̂PpXڂ̒_VF[_[
	int						GaussPass1_PS ;							// KEXtB^VF[_[̂PpXڂ̃sNZVF[_[
	int						GaussPass2_VS ;							// KEXtB^VF[_[̂QpXڂ̒_VF[_[
	int						GaussPass2_PS ;							// KEXtB^VF[_[̂QpXڂ̃sNZVF[_[

	BYTE					*VertexBufferNextAddress ;				// ̃f[^i[ׂ_obt@̃AhX
	BYTE					NoTexVertexBuffer[     D3DDEV_NOTEX_VERTBUFFERSIZE     ] ;	// eNX`gpȂ_obt@
	BYTE					TexVertexBuffer[       D3DDEV_TEX_VERTBUFFERSIZE       ] ;	// eNX`gp钸_obt@
	BYTE					BlendTexVertexBuffer[  D3DDEV_BLENDTEX_VERTBUFFERSIZE  ] ;	// uheNX`gp钸_obt@
	BYTE					Vertex3DBuffer[	       D3DDEV_NOTEX_3D_VERTBUFFERSIZE  ] ;	// Rcp_obt@

	void					*CommonBuffer[ COMMON_BUFFER_NUM ] ;	// ėpobt@
	DWORD					CommonBufferSize[ COMMON_BUFFER_NUM ] ;	// ėpobt@̃mۃTCY

	RECT					DrawRect ;							// `͈

	DX_DIRECT3DTEXTURE9		*RenderTexture ;					// `掞ɎgpeNX`[
	DX_DIRECT3DTEXTURE9		*BlendTexture ;						// `掞ɕ`eNX`[ƃuh郿`leNX`[
	DX_DIRECT3DTEXTURE9		*RenderTargetTexture ;				// `ΏۂƂȂĂeNX`[
	DX_DIRECT3DSURFACE9		*RenderTargetSurface ;				// `ΏۂƂȂĂeNX`[̃T[tFX
	DX_DIRECT3DSURFACE9		*RenderTargetCopySurface ;			// `ΏۂƂȂĂeNX`[̃Rs[T[tFX
	float					RenderTargetTextureInvWidth ;		// `ΏۂƂȂĂeNX`[̕1.0f
	float					RenderTargetTextureInvHeight ;		// `ΏۂƂȂĂeNX`[̍1.0f
#ifndef DX_NON_MODEL
	DX_DIRECT3DVOLUMETEXTURE9	*RGBtoVMaxRGBVolumeTexture ;	// RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`
#endif // DX_NON_MODEL

	DIRECT3DBLENDINFO		BlendInfo ;							// Direct3DDevice ̃uhɊ֌Wݒl
	float					FactorColorPSConstantF[ 4 ] ;		// sNZVF[_[gcwCuWp FactorColor ̒l
	DIRECT3DBLENDINFO		UserBlendInfo ;						// Direct3D ǗvOOݒ肳uhɊ֌Wݒl
	int						UserBlendInfoFlag ;					// UserBlendInfo LǂtO( TRUE:L  FALSE: )
	int						UserBlendInfoTextureStageIsTextureAndTextureCoordOnlyFlag ;	// UserBlendInfo.TextureStageInfo ̒ŗLȃp[^ Texture  TextureCoordIndex ǂ( TRUE:̒ʂ  FALSE:Ⴄ )

	int						DrawMode ;							// `惂[h
	int						MaxAnisotropy ;						// őٕ
	int						MaxAnisotropyDim[ 8 ] ;				// eTv̍őٕ
	DX_D3DTEXFILTER_TYPE	MagFilter[ 8 ] ;					// eTv̊gtB^
	DX_D3DTEXFILTER_TYPE	MinFilter[ 8 ] ;					// eTv̏ktB^
	DX_D3DTEXFILTER_TYPE	MipFilter[ 8 ] ;					// eTṽ~bv}bvtB^
	int						EnableZBufferFlag ;					// yobt@̗LtO
	int						WriteZBufferFlag ;					// yobt@̍XVsAtO
	int						ZBufferCmpType ;					// yl̔r[h
	int						ZBias ;								// yoCAX
	int						TextureTransformUse[ 8 ] ;				// eNX`Wϊsgp邩ǂ( TRUE:gp  FALSE:gpȂ )
	MATRIX					TextureTransformMatrix[ 8 ] ;			// eNX`Wϊs
	int						TextureTransformMatrixDirectChange ;	// eNX`Wϊs𒼐ڕύXꂽǂ( TRUE:ꂽ  FALSE:ĂȂ )

	int						ShadowMapDrawSetupRequest ;			// VhE}bvɑ΂`揀NGXg
	int						ShadowMapDraw ;						// VhE}bvɑ΂`悩ǂ̃tO
	int						ShadowMapDrawHandle ;				// VhE}bvɑ΂`̍ۂ́AVhE}bvnh
	int						NormalizeNormals ;					// @Ksǂ
	int						ShadeMode ;							// VF[fBO[h
	int						FillMode ;							// tB[h
	int						CullMode ;							// JO[h
	int						TexAddressModeU[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[ht
	int						TexAddressModeV[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[hu
	int						TexAddressModeW[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[hv
	int						FogEnable ;							// tHOLǂ( TRUE:L  FALSE: )
	int						FogMode ;							// tHO[h
	DWORD					FogColor ;							// tHOJ[
	float					FogStart, FogEnd ;					// tHOJnAhXƏIAhX
	float					FogDensity ;						// tHOx
	int						PerspectiveFlag ;					// p[XyNeBu␳LtO

	int						LightFlag ;							// Cggp邩tO
	int						LightEnableMaxIndex ;				// LȃCg̍őCfbNX
	int						LightEnableFlag[ 256 ] ;			// CgLǂtO( TRUE:L  FALSE: )
	LIGHT					LightParam[ 256 ] ;					// Cg̃p[^

	COLOR					GlobalAmbientLightColor ;			// O[oArGgCgJ[
	MATERIAL				Material ;							// foCXɃZbgĂ}eA
	int						MaterialUseVertexDiffuseColor ;		// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂ
	int						MaterialUseVertexSpecularColor ;	// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂ
	int						UseSpecular ;						// XyLgp邩ǂ

	int						UseDiffuseRGBColor ;				// fBt[YJ[̂qfalgp邩AtO
	int						UseDiffuseAlphaColor ;				// fBt[YJ[̃lgp邩AtO
	int						BeginSceneFlag ;					// BeginScene sĂ邩ǂ

	int						IgnoreGraphColorFlag ;				// `悷摜̐F𖳎邩ǂ̃tO

	int						UseAlphaChDrawShader ;				// `ɐlވׂ̃VF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )
	int						BlendMode ;							// uh[h
	int						BlendGraphType ;					// uh摜^Cv
	int						BlendGraphFadeRatio ;				// uh摜̃tF[hp[^
	int						BlendGraphBorderParam ;				// uh摜̋Ep[^(O(uh摜̉eO)@@(uh摜̉eȂ)@@PQW(uh摜̉ePOO)@@(uh摜̉e𒴂Ĕ`敔)@QTT(S`悳Ȃ) )
	int						BlendGraphBorderRange ;				// uh摜̋E(O`QTT@`L@SiK)
	int						AlphaChannelValidFlag ;				// `lLtO

	int						AlphaTestMode ;						// At@eXg[h
	int						AlphaTestParam ;					// At@eXgp[^

	int						AlphaTestValidFlag ;				// eXgLtO( Func ͕K D_D3DCMP_GREATEREQUAL )
	int						ChangeBlendParamFlag ;				// uhݒɊւ镔̕ύXAtO
	int						ChangeTextureFlag ;					// eNX`ύXꂽAtO
	int						BlendMaxNotDrawFlag ;				// uhlőł邱Ƃɂ`sȂǂAtO
	int						EdgeFontDrawFlag ;					// ttHg`悷邩ǂ̃tO


	int						DrawScreenBufferLockFlag ;			// obNobt@bNĂ邩ǂtO
	DX_DIRECT3DSURFACE9		*DrawScreenBufferLockSMSurface ;	// obNobt@bNۂɒڃbNłȂꍇɎgpT[tFX̃|C^
	DX_DIRECT3DSURFACE9		*DrawScreenBufferLockSurface ;		// bNobNobt@

	void					(*DeviceRestoreCallbackFunction)( void *Data ) ;	// foCXXg畜AƂɌĂԊ֐
	void					*DeviceRestoreCallbackData ;		// foCXXg畜AƂɌĂԊ֐ɓn|C^

	void					(*DeviceLostCallbackFunction)( void *Data ) ;	// foCXXg畜AOɌĂԊ֐
	void					*DeviceLostCallbackData ;			// foCXXg畜AOɌĂԊ֐ɓn|C^

	int						UseShader ;							// vO}uVF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )
	int						NormalDraw_NotUseShader ;			// ʏ`ɃVF[_[gpȂǂ( TRUE:gpȂ  FALSE:gp )
#ifndef DX_NON_FILTER
	int						ValidRenderTargetInputTexture ;		// `̓eNX`ƂĎgpł邩ǂ( TRUE:gpł  FALSE:gpłȂ )
#endif // DX_NON_FILTER

	DX_DIRECT3DVERTEXSHADER9		*SetVS ;					//  Direct3DDevice9 ɃZbgĂ钸_VF[_[
	DX_DIRECT3DPIXELSHADER9			*SetPS ;					//  Direct3DDevice9 ɃZbgĂsNZVF[_[
	int								NormalPS ;					// ʏ`psNZVF[_[ZbgĂ邩ǂ
	DX_DIRECT3DVERTEXDECLARATION9	*SetVD ;					//  Direct3DDevice9 ɃZbgĂ钸_VF[_錾
	DWORD							SetFVF ;					//  Direct3DDevice9 ɃZbgĂ FVF R[h
	DX_DIRECT3DVERTEXBUFFER9		*SetVB ;					//  Direct3DDevice9 ɃZbgĂ钸_obt@
	DX_DIRECT3DINDEXBUFFER9			*SetIB ;					//  Direct3DDevice9 ɃZbgĂCfbNXobt@

	// Œ@\pCvC݊̃VF[_[( eNX`Ȃ )
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ `llłǂ( 0:lȂ  1:l ) ]
	// [ Zς݃uhpǂ( 0:Zς݃uhpł͂Ȃ  1:Zς݃uhp ) ]
	DX_DIRECT3DPIXELSHADER9          *BaseNoneTexPixelShader[ 7 ][ 2 ] ;

	// Œ@\pCvC݊̃VF[_[( eNX` )
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ `llłǂ( 0:lȂ  1:l ) ]
	DX_DIRECT3DPIXELSHADER9          *BaseUseTexPixelShader[ 4 ][ 7 ][ 2 ][ 2 ][ 2 ] ;

	// }XNp̃VF[_[
	DX_DIRECT3DPIXELSHADER9          *MaskEffectPixelShader ;

#ifndef DX_NON_MODEL
	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	DX_DIRECT3DVERTEXSHADER9         *MV1_PixelLighting_VertexShader[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[psNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O Type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	DX_DIRECT3DPIXELSHADER9         *MV1_PixelLighting_ToonPixelShader[ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 84 ][ 2 ] ;

	// f`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	DX_DIRECT3DPIXELSHADER9         *MV1_PixelLighting_PixelShader[ 2 ][ 5 ][ 2 ][ 2 ][ 84 ][ 2 ] ;





	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	DX_DIRECT3DVERTEXSHADER9         *MV1_ToonOutLineVertexShader[ 3 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	DX_DIRECT3DVERTEXSHADER9         *MV1_ShadowMapVertexShader[ 3 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	DX_DIRECT3DVERTEXSHADER9         *MV1_NoLightingVertexShader[ 3 ][ 4 ] ;

	// f`p̃CeBO蒸_VF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	DX_DIRECT3DVERTEXSHADER9         *MV1_LightingVertexShader[ 2 ][ 2 ][ 3 ][ 2 ][ 4 ][ 20 ][ 2 ] ;


	// f`p̃gD[_O̗֊s`psNZVF[_[
	DX_DIRECT3DPIXELSHADER9         *MV1_ToonOutLinePixelShader ;

	// f`p̃VhE}bvւ̃_OpsNZVF[_[
	DX_DIRECT3DPIXELSHADER9         *MV1_ShadowMapPixelShader ;

	// f`p̃CeBOȂgD[psNZVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	DX_DIRECT3DPIXELSHADER9         *MV1_ToonNoLightingPixelShader[ 2 ][ 2 ] ;

	// f`p̃CeBOȂsNZVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	DX_DIRECT3DPIXELSHADER9         *MV1_NoLightingPixelShader[ 5 ] ;

	// f`p̃CeBOgD[psNZVF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	DX_DIRECT3DPIXELSHADER9         *MV1_ToonLightingPixelShader[ 2 ][ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ 2 ] ;

	// f`p̃CeBOsNZVF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	DX_DIRECT3DPIXELSHADER9         *MV1_LightingPixelShader[ 2 ][ 2 ][ 5 ][ 2 ][ 2 ][ 10 ][ 2 ] ;




	// _VF[_錾( Xg͔z̍ )
	// [ ov}bvtǂ( 1:ov}bvt 0:tĂȂ ) ]
	// [ XLjObVǂ( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ UV̐ ]
	DX_DIRECT3DVERTEXDECLARATION9    *DefaultVertexDeclaration[ 2 ][ 3 ][ 9 ] ;

#endif // DX_NON_MODEL

	int						InitializeFlag ;					// ̃tOĂ鎞݂͌̃Xe[^XƕύX
																// w̃Xe[^XłKs
	int						DisplayModeNum ;					// ύX\ȃfBXvC[h̐
	DISPLAYMODEDATA			*DisplayMode ;						// fBXvC[hXg

	SHADERCONSTANTINFOSET	ShaderConstantInfo ;				// VF[_[̒萔

	DX_DIRECT3DVERTEXDECLARATION9	*UserShaderDeclaration[ DX_VERTEX_TYPE_NUM ] ;	// [U[VF[_[hŎgp钸_f[^tH[}bg

	USERRENDERINFO			UserShaderRenderInfo ;				// SetUseTextureToShader Őݒ肳ꂽeXe[W̃eNX`A[U[ݒ̃VF[_[萔Ȃ

	int						WorkDrawValidGrHandle[ 2 ][ 16 ][ 2 ] ;	// tB^[Ɨp`\eNX`[ 0:eNX` 1:_eNX` ][ Q̂ ][ ƗpQ ]
#ifndef DX_NON_FILTER
	SHADERCODE_HANDLE		ShaderCode ;						// CupӂVF[_[R[h
#endif // DX_NON_FILTER
} ;

// \tgEGA_OŎgp̍\
struct GRAPHICS_SOFTDATA
{
	MEMIMG					MainBufferMemImg ;					// Cʗp MEMIMG
	MEMIMG					FontScreenMemImgNormal ;			// `Ȃǂ̎ɎgtHgp MEMIMG ( At@Ȃ )
	MEMIMG					FontScreenMemImgAlpha ;				// `Ȃǂ̎ɎgtHgp MEMIMG ( At@ )
	MEMIMG					*TargetMemImg ;						// `Ώۂ MEMIMG
	MEMIMG					*BlendMemImg ;						// uh`p MEMIMG
} ;

// OtBbNǗf[^\
struct GRAPHICSMANAGE2
{
	int						InitializeFlag ;						// tO

	int						MainScreenSizeX, MainScreenSizeY ;		// Cʂ̃TCY
	int						MainScreenSizeX_Result, MainScreenSizeY_Result ;	// GetDrawScreenSize ̕ԂlɂȂTCY
	int						MainScreenColorBitDepth ;				// Cʂ̃J[rbg[x
	int						MainScreenRefreshRate ;					// Cʂ̃tbV[g
	RECT					OriginalDrawRect ;						// EChËʒuɂĉςO̎gp҂Ӑ}鐳``
	int						UseChangeDisplaySettings ;				// ChangeDisplaySettings gpĉʃ[hύXǂ( TRUE:ChangeDisplaySettings gp  FALSE:ChangeDisplaySettings ͎gpĂȂ )
	int						ChangeGraphModeFlag ;					// ChangeGraphMode sǂ̃tO

	int						ValidGraphDisplayArea ;					// GraphDisplayArea ɗLȒlĂ邩ǂ
	RECT					GraphDisplayArea ;						// \ʂɓ]闠ʂ̗̈
	RECT					LastCopySrcRect ;						// ŌɃtBbg]Ƃ̃Rs[`
	RECT					LastCopyDestRect ;						// ŌɃtBbg]Ƃ̃Rs[`
	int						EnableBackgroundColor;					// obNOEhhׂpJ[Lǂ̃tO
	int						BackgroundRed, BackgroundGreen, BackgroundBlue;	// obNOEhhׂpJ[

	LONGLONG				VSyncWaitTime ;							// Ourxmb҂Ă玟Ƀ`FbN܂łɑ҂
	LONGLONG				VSyncTime ;								// Ourxmb҂

	int						ValidHardWare ;							// n[hEGA`悪\ǂ( TRUE:\  FALSE:s\ )
	int						NotUseHardWare ;						// n[hEGA`̋@\gpȂǂ( TRUE:gpȂ  FALSE:gp )
	int						ChangeScreenModeNotGraphicsSystemFlag ;	// ʃ[h̕ύXɉ摜nh폜Ȃǂ( TRUE:Ȃ  FALSE: )


	int						ShaderInitializeFlag ;					// VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	DXARC					BaseShaderBinDxa ;						// {VF[_[IuWFNgt@Ccw`\
	void					*BaseShaderBinDxaImage ;				// {VF[_[IuWFNgt@Ccw`̃oCiC[W

#ifndef DX_NON_FILTER
	DXARC					FilterShaderBinDxa ;					// tB^[VF[_[IuWFNgt@Ccw`\
	void					*FilterShaderBinDxaImage ;				// tB^[VF[_[IuWFNgt@Ccw`̃oCiC[W

	void					*RGBAMixS_ShaderPackImage ;				// RGBAMix  S ̑gݍ킹QTU̃VF[_[pbP[WoCiC[W

	// RGBAMix  S ̑gݍ킹QTU̃VF[_[[ R ][ G ][ B ][ A ]
	void					*RGBAMixS_ShaderAddress[ 4 ][ 4 ][ 4 ][ 4 ] ;
	short					RGBAMixS_ShaderSize[ 4 ][ 4 ][ 4 ][ 4 ] ;
#endif // DX_NON_FILTER

	// CgCfbNXXg
	short					LightIndexList84[ 4 ][ 4 ][ 4 ][ 4 ][ 4 ][ 4 ] ;
	short					LightIndexList20[ 4 ][ 4 ][ 4 ] ;

	short					LightIndexList10[ 3 ][ 3 ][ 3 ] ;

#ifndef DX_NON_MODEL
	void					*ModelShaderPackImage ;					// RcfpVF[_[pbP[WoCiC[W

	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	void					*MV1_PixelLighting_VertexShaderAddress[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[psNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_Oǂ( 0:gD[_O type 1   1:gD[_O Type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_PixelLighting_ToonPixelShaderAddress[ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 84 ][ 2 ] ;

	// f`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_PixelLighting_PixelShaderAddress[ 2 ][ 5 ][ 2 ][ 2 ][ 84 ][ 2 ] ;






	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	void					*MV1_ToonOutLineVertexShaderAddress[ 3 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	void					*MV1_ShadowMapVertexShaderAddress[ 3 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	void					*MV1_NoLightingVertexShaderAddress[ 3 ][ 4 ] ;

	// f`p̃CeBO蒸_VF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_LightingVertexShaderAddress[ 2 ][ 2 ][ 3 ][ 2 ][ 4 ][ 20 ][ 2 ] ;


	// f`p̃gD[_O̗֊s`psNZVF[_[
	void					*MV1_ToonOutLinePixelShaderAddress ;

	// f`p̃VhE}bvւ̃_OpsNZVF[_[
	void					*MV1_ShadowMapPixelShaderAddress ;

	// f`p̃CeBOȂgD[psNZVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	void					*MV1_ToonNoLightingPixelShaderAddress[ 2 ][ 2 ] ;

	// f`p̃CeBOȂsNZVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	void					*MV1_NoLightingPixelShaderAddress[ 5 ] ;

	// f`p̃CeBOgD[psNZVF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_ToonLightingPixelShaderAddress[ 2 ][ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ 2 ] ;

	// f`p̃CeBOsNZVF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_LightingPixelShaderAddress[ 2 ][ 2 ][ 5 ][ 2 ][ 2 ][ 10 ][ 2 ] ;

#endif // DX_NON_MODEL

	GRAPHICS_HARDDATA		Hard ;									// n[hEFAANZ[^gp鏈ɕKvȏ
	GRAPHICS_SOFTDATA		Soft ;									// \tgEGA_OgpۂɕKvȏ
} ;

// ϐ錾---------------------------------------------------------------

// OtBbNXǗf[^\
extern GRAPHICSMANAGE2 GraphicsManage2 ;

// ֐vg^Cv錾-----------------------------------------------------------

// OtBbN֘Ȁƌn
extern	int		InitializeGraphics2( void ) ;
extern	int		TerminateGraphics2( void ) ;

extern	int		SetZBufferMode( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth ) ;	// Cʂ̂yobt@̐ݒύX
extern	void	SetMainScreenSize( int SizeX, int SizeY ) ;									// Cʂ̃TCYlύX
extern	void	ReleaseDirectXObject( void ) ;												// DirectX ̃IuWFNg
extern	void	BeginScene( void ) ;														// rMV[s	
extern	void	EndScene( void ) ;															// GhV[s	
extern	int		RenderVertexHardware( int ASyncThread = FALSE ) ;							// _obt@ɗ܂_f[^_O
extern	int		SetRenderTargetHardware( DX_DIRECT3DSURFACE9 *TargetSurface, int TargetIndex = 0 ) ;	// `Ώۂ̕ύX
extern	int		SetViewportHardwareEasy( int x1, int y1, int x2, int y2 ) ;					// r[|[gZbg( ȈՔ )
extern	int		SetupUseZBuffer( void ) ;													// ݒɊÂĎgpyobt@Zbg
extern	int		CreateSubBackBufferSurface( void ) ;										// ScreenCopy  GetDrawScreen 邽߂Ɏgpe|obt@̍쐬( 0:  -1:s )
extern COLORDATA *GetD3DFormatColorData( D_D3DFORMAT Format ) ;								// D3DFORMAT ̃tH[}bgɍ킹J[tH[}bg擾
extern	void FASTCALL SetDrawBrightToOneParam( DWORD Bright ) ;								// SetDrawBright ̈
extern	void FASTCALL BlendModeSub_Pre( RECT *DrawRect ) ;
extern	void FASTCALL BlendModeSub_Post( RECT *DrawRect ) ;
extern	void FASTCALL AlphaChDraw_Pre( RECT *DrawRect ) ;
extern	int		GetWorkTexture( int IsFloatType, DWORD TexSizeW, DWORD TexSizeH, DWORD HandleIndex ) ;
extern	int		SetUseAutoMipMap( int UseFlag, int MaxLevel = -1 ) ;
extern	int		ChangeGraphMode( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int ChangeWindowFlag, int RefreshRate ) ;				// ʃ[h̕ύXQ
extern	int		SetD3DDialogBoxMode( int Flag ) ;
#ifndef DX_NON_MODEL
extern	int		SetupShader( int VertexShaderIndex, int VertexShaderIndex_SM3, int PixelShaderIndex, int PixelShaderIndex_SM3 ) ;	// w̃VF[_[ZbgAbv( TRUE:  FALSE:s )
extern	int		SetupVertexDeclaration( int BumpMap, int SkinMesh, int UVNum ) ;											// w̒_f[^`ZbgAbv
#endif // DX_NON_MODEL
extern	int		SetDeviceVertexShaderToHandle( int ShaderHandle ) ;															// w̒_VF[_[foCXɃZbg
extern	int		SetDevicePixelShaderToHandle( int ShaderHandle ) ;															// w̃sNZVF[_[foCXɃZbg
extern	int		LockDrawScreenBuffer( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen/* = -1*/, int TargetScreenSurface/* = -1*/, int ReadOnly/* = TRUE*/, int TargetScreenTextureNo/* = 0*/ ) ;	// `obt@bN
extern	int		UnlockDrawScreenBuffer( void ) ;																			// `obt@AbN
extern	int		SetBlendGraphParamBase( int BlendGraph, int BlendType, va_list ParamList ) ;								// SetBlendGraphParam ̉ϒp[^t
extern	int		GraphFilterRectBltBase( int IsBlend, int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int BlendRatio, int FilterOrBlendType, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX, int BlendY, int BlendPosEnable, int DestX, int DestY, va_list ParamList ) ;		// 摜̃tB^[t]s( ψt )

extern	int		SysMemTextureProcess( void ) ;																				// ǗeNX`ւ̓]p̃VXeeNX`̒s

extern	int		CreateShaderHandle( void ) ;																				// VF[_[nh쐬
extern	int		CreateShader_UseGParam( int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;		// VF[_[nh쐬
extern	int		LoadShader_UseGParam( int IsVertexShader, const TCHAR *FileName, int ASyncLoadFlag = FALSE ) ;				// VF[_[oCit@Cǂݍ

extern	int		InitializeShaderHandle( HANDLEINFO *HandleInfo ) ;															// VF[_[nh̏
extern	int		TerminateShaderHandle( HANDLEINFO *HandleInfo ) ;															// VF[_[nȟn

extern	int		SetupVertexBufferHandle( int VertexBufHandle, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ ) ;	// _obt@nh̃ZbgAbvs
extern	int		InitializeVertexBufferHandle( HANDLEINFO *HandleInfo ) ;													// _obt@nh̏
extern	int		TerminateVertexBufferHandle( HANDLEINFO *HandleInfo ) ;														// _obt@nȟn

extern	int		SetupIndexBufferHandle( int IndexBufHandle, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ ) ;	// CfbNXobt@nh̃ZbgAbvs
extern	int		InitializeIndexBufferHandle( HANDLEINFO *HandleInfo ) ;														// CfbNXobt@nh̏
extern	int		TerminateIndexBufferHandle( HANDLEINFO *HandleInfo ) ;														// CfbNXobt@nȟn

// DirectX ֘A֐
extern	int		InitializeDirectX() ;									// DirectX ֘Ȁ( 0:  -1:s )
extern	int		TerminateDirectX() ;									// DirectX ֘Ǎn

extern	int		CreateDirect3D9DeviceObject() ;							// Direct3DDevice9 IuWFNg̍쐬( 0:  -1:s )

extern	int		SetupDirect3D9Shader() ;								// Direct3D9 ̃VF[_[̃ZbgAbvs( 0:  -1:s )
extern	int		TerminateDirect3D9Shader() ;							// Direct3D9 ̃VF[_[̌n( 0:  -1:s )

extern	int		CreateDirect3D9VertexDeclaration() ;					// Direct3DVertexDeclaration9 IuWFNg̍쐬( 0:  -1:s )
extern	int		TerminateDirect3D9VertexDeclaration() ;					// Direct3DVertexDeclaration9 IuWFNg̍폜( 0:  -1:s )

#ifndef DX_NON_MODEL
extern	int		CreateRGBtoVMaxRGBVolumeTexture() ;						// RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`쐬( 0:  -1:s )
#endif // DX_NON_MODEL

extern	int		CreateDirect3D9ZBufferObject() ;						// yobt@IuWFNg̍쐬( 0:  -1:s )


// n[hEGAݒ֌W֐
extern	void	ApplyLibMatrixToHardware( void ) ;						// {f[^ɐݒ肳Ăsn[hEGAɔf
extern	void	ApplyLigFogToHardware( void ) ;							// {f[^ɐݒ肳ĂtHOn[hEGAɔf

extern	int		D_SetVertexBlend( int WeightNum ) ;					// suh̐ݒ肷( DrawGraph ȂǂĂԑO 0 ɂČĂяoȂƂ̌̕`悪ɍsȂȂ܂ )
extern	int		D_DrawIndexedPrimitive( void *VertexBuffer9, DWORD VertexStride, DWORD FVFFlag, void *IndexBuffer9, int PrimitiveType, int BaseVertexIndex, DWORD MinIndex, DWORD NumVertices, DWORD StartIndex, DWORD PrimitiveCount ) ;						// Direct3DDevice9->DrawIndexedPrimitive ̃bsO֐
extern	int		D_DrawIndexedPrimitiveUP( DWORD FVFFlag, int PrimitiveType, DWORD MinVertexIndex, DWORD NumVertexIndices, DWORD PrimitiveCount, void *pIndexData, D_D3DFORMAT IndexDataFormat, void *pVertexStreamZeroData, DWORD VertexStreamZeroStride ) ;		// Direct3DDevice9->DrawIndexedPrimitiveUP ̃bsO֐
extern	int		D_SetLightEnable( int Flag ) ;											// CgLɂ邩ǂZbg
extern	int		D_SetLightParam( int No, int EnableFlag, LIGHTPARAM *Param = NULL ) ;	// Cg̃p[^Zbg
extern	int		D_SetAmbientLight( int r, int g, int b ) ;								// ArGgCgݒ肷
extern	int		D_SetUseSpecular( int UseFlag ) ;										// XyLgp邩ǂݒ肷
extern	int		D_SetMaterial( MATERIALPARAM *Param ) ;									// }eAp[^Zbg
extern	int		D_SetMaterialUseVertexDiffuseColor( int UseFlag ) ;						// _fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
extern	int		D_SetMaterialUseVertexSpecularColor( int UseFlag ) ;						// _XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
extern	int		D_SetShadeMode( int ShadeMode ) ;										// VF[h[hZbg
extern	int		D_GetShadeMode( void ) ;													// VF[h[h擾
extern	int		D_SetMaxAnisotropy( int TexStage, int MaxAnisotropy ) ;					// őٕZbg
extern	int		D_SetUseCullingFlag( int Flag ) ;										// |SJO̗LAZbg
extern	int		D_SetupZBuffer3D( void ) ;												// Rc`p̂yobt@ݒn[hɔf
extern	int		D_SetupUseVertColor( void ) ;											// _J[gp邩ǂ̐ݒn[hɔf
extern	int		D_SetUseZBufferFlag( int Flag ) ;										// yobt@Lɂ邩AtOZbg
extern	int		D_SetWriteZBufferFlag( int Flag ) ;										// yobt@ɏ݂sAtOZbg
extern	int		D_SetDrawAlphaTest( int TestMode, int TestParam ) ;						// `掞̃At@eXg̃[hZbg
extern	int		D_SetZBufferCmpType( int CmpType /* DX_CMP_NEVER  */ )	;				// yl̔r[hZbg
extern	int		D_SetZBias( int Bias ) ;													// yoCAXZbg
extern	int		D_SetFillMode( int FillMode ) ;												// tB[hZbg
extern	int		D_SetTextureAddressMode( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage = -1 ) ;	// eNX`AhX[hݒ肷
extern	int		D_SetTextureAddressModeUVW( int ModeU, int ModeV, int ModeW, int Stage ) ;			// eNX`AhX[hݒ肷
extern	int		D_SetTextureAddressTransformMatrix( int Use, MATRIX *Matrix, int Stage = -1 ) ;		// eNX`WϊsZbg
extern	int		D_SetTransformToWorld( MATRIX *Matrix ) ;								// [J[hsύX
extern	int		D_SetTransformToView( MATRIX *Matrix ) ;									// r[ϊpsZbg
extern	int		D_SetTransformToProjection( MATRIX *Matrix ) ;							// eϊpsZbg
extern	int		D_ResetTextureCoord( void ) ;											// eXe[WgpeNX`AhXXe[WԍƓɂ
extern	int		_SetTransformToProjection( const MATRIX *Matrix ) ;						// eϊpsZbg
//extern	int		RenderVertexBuffer( void ) ;										// _obt@ɗ܂_f[^fo
extern	void	_DrawPreparation( int GrHandle = -1 , int ParamFlag = 0 ) ;										// `揀s( ParamFlag  DRAWPREP_TRANS  )



extern	int		AddGraphHandle( void ) ;																						// VOtBbNnhmۂ
extern	int		SetupGraphHandle_UseGParam( SETUP_GRAPHHANDLE_GPARAM *GParam, int GrHandle, int Width, int Height, int TextureFlag, int AlphaValidFlag, int UsePaletteFlag, int BaseFormat/* = DX_BASEIMAGE_FORMAT_NORMAL*/, int MipMapCount, int ASyncThread ) ;							// SetupGraphHandle ̃O[oϐɃANZXȂo[W

extern	int		InitializeGraphHandle( HANDLEINFO *HandleInfo ) ;																// OtBbNnh̏
extern	int		TerminateGraphHandle( HANDLEINFO *HandleInfo ) ;																// OtBbNnȟn

extern	int		AddShadowMapHandle( void ) ;																						// VVhE}bvnhmۂ
extern	int		SetupShadowMapHandle_UseGParam( SETUP_SHADOWMAPHANDLE_GPARAM *GParam, int SmHandle, int SizeX, int SizeY, int TexFormat_Float, int TexFormat_BitDepth, int ASyncThread ) ;	// VhE}bvnh̃ZbgAbvs
extern	int		CreateShadowMapTexture( SHADOWMAPDATA *ShadowMap, int ASyncThread = FALSE ) ;										// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		ReleaseShadowMapTexture( SHADOWMAPDATA *ShadowMap ) ;																// VhE}bvf[^ɕKvȃeNX`
extern	SHADOWMAPDATA	*GetShadowMapData( int SmHandle, int ASyncThread = FALSE ) ;												// VhE}bvf[^nhlo
extern	void	RefreshShadowMapVSParam( void ) ;																					// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	RefreshShadowMapPSParam( void ) ;																					// sNZVF[_[ɐݒ肷VhE}bv̏XV

extern	int		InitializeShadowMapHandle( HANDLEINFO *HandleInfo ) ;																// VhE}bvnh̏
extern	int		TerminateShadowMapHandle( HANDLEINFO *HandleInfo ) ;																// VhE}bvnȟn

extern	int		AllocCommonBuffer( int Index, DWORD Size ) ;																	// L̊m
extern	int		TerminateCommonBuffer( void ) ;																					// L̉

extern	int		CreateDXGraph_UseGParam( SETUP_GRAPHHANDLE_GPARAM *GParam, int GrHandle, const BASEIMAGE *RgbImage, const BASEIMAGE *AlphaImage, int TextureFlag, int ASyncThread = FALSE ) ;																															// CreateDXGraph ̃O[oϐɃANZXȂo[W
extern	int		DerivationGraph_UseGParam( int SrcX, int SrcY, int Width, int Height, int SrcGraphHandle, int ASyncThread = FALSE ) ;																																												// DerivationGraph ̃O[oϐɃANZXȂo[W
#ifndef DX_NON_MOVIE
extern	int		LoadBmpToGraph_OpenMovie_UseGParam( LOADGRAPH_GPARAM *GParam, int GrHandle, const TCHAR *GraphName, int TextureFlag, int SurfaceMode = DX_MOVIESURFACE_NORMAL, int ASyncThread = FALSE ) ;
#endif

extern	int		DerivationGraphBase( int GrHandle, int SrcX, int SrcY, int Width, int Height, int SrcGraphHandle, int ASyncThread = FALSE ) ;																																								// OtBbNnh쐬Ȃ DerivationGraph
extern	int		SetGraphBaseInfo_UseGParam( SETGRAPHBASEINFO_GPARAM *GParam, int GrHandle, const TCHAR *FileName, const COLORDATA *BmpColorData, HBITMAP RgbBmp, HBITMAP AlphaBmp, const void *MemImage, int MemImageSize,
										   const void *AlphaMemImage, int AlphaMemImageSize, const BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int ReverseFlag, int UnionGrHandle, int ASyncThread ) ;																														// SetGraphBaseInfo ̃O[oϐɃANZXȂo[W
extern	int		SetGraphName_UseGParam( SETGRAPHBASEINFO_GPARAM *GParam, int Handle, const TCHAR *GraphName, int ReverseFlag, int UnionGrHandle, int ASyncThread ) ;																																		// SetGraphName ̃O[oϐɃANZXȂo[W

extern	int		FillGraph_UseGParam( int GrHandle, int Red, int Green, int Blue, int Alpha, int ASyncThread ) ;																																																// FillGraph ̃O[oϐɃANZXȂo[W

extern	int		SetGraphName( int Handle, const TCHAR *GraphName, int ReverseFlag, int UnionGrHandle, int ASyncThread ) ;	// ̃t@C摜ǂݍ񂾏ꍇ̃t@CpXZbg
extern	int		IsValidGraphHandle( int GrHandle ) ;															// OtBbNnhLǂ𒲂ׂ( TRUE:L  FALSE: )


extern	int		ScreenFlipBase( RECT *CopyRect ) ;											// ScreenFlip ̃x[X֐
extern	int		SetGraphBaseInfo( int GrHandle, const TCHAR *FileName, const COLORDATA *BmpColorData, HBITMAP RgbBmp, HBITMAP AlphaBmp, const void *MemImage, int MemImageSize, const void *AlphaMemImage, int AlphaMemImageSize, const BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int ReverseFlag, int UnionGrHandle, int ASyncThread ) ;		// 摜̌f[^̏ۑ

extern	int		BltBmpOrGraphImageToGraphBase(    const COLORDATA *SrcColorData, HBITMAP Bmp, HBITMAP AlphaMask, int BmpFlag, const BASEIMAGE *RgbImage, const BASEIMAGE *AlphaImage, int CopyPointX, int CopyPointY, int GrHandle, int UseTransColorConvAlpha = TRUE, int ASyncThread = FALSE ) ;											// BltBmpOrGraphImageToGraph ̓֐
extern	int		BltBmpOrGraphImageToGraph2Base(   const COLORDATA *SrcColorData, HBITMAP Bmp, HBITMAP AlphaMask, int BmpFlag, const BASEIMAGE *RgbImage, const BASEIMAGE *AlphaImage, const RECT *SrcRect, int DestX, int DestY, int GrHandle ) ;																							// BltBmpOrGraphImageToGraph2 ̓֐
extern	int		BltBmpOrGraphImageToDivGraphBase( const COLORDATA *SrcColor,     HBITMAP Bmp, HBITMAP AlphaMask, int BmpFlag, const BASEIMAGE *RgbImage, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int Width, int Height, const int *GrHandle, int ReverseFlag, int UseTransColorConvAlpha = TRUE, int ASyncThread = FALSE ) ;	// BltBmpOrGraphImageToDivGraph ̓֐

extern	int		SetUserBlendInfo( DIRECT3DBLENDINFO *BlendInfo, int TextureStageIsTextureAndTextureCoordOnlyFlag = FALSE ) ;	// eNX`Xe[WXe[g𒼐ڎw肷( NULL Ŗ )
extern	int		D_SetSampleFilterMode( int TexStage, int SetTarget, DX_D3DTEXFILTER_TYPE FilterType ) ;	// eNX`tB^O[hݒ肷
extern	DX_D3DTEXFILTER_TYPE D_GetSampleFilterMode( int TexStage, int SetTarget ) ;		// eNX`tB^O[h擾
extern	int		D_SetUserBlendInfo( DIRECT3DBLENDINFO *BlendInfo, int TextureStageIsTextureAndTextureCoordOnlyFlag, int TextureIsGraphHandleFlag = TRUE ) ;	// [U[̃uhCtHK
extern IMAGEDATA2 *GetGraphData2( int GrHandle, int ASyncThread = FALSE ) ;					// OtBbÑf[^CfbNXlo
extern	D_D3DXSHADER_CONSTANTINFO *GetShaderConstInfo( SHADERHANDLEDATA *Shader, const TCHAR *ConstantName ) ;				// VF[_[̒萔𓾂

extern	int		InitializeShaderConstantUseArea( SHADERCONSTANT_USEAREA *UseArea, int TotalSize ) ;							// VF[_[萔gp̈
extern	int		SetShaderConstantUseArea( SHADERCONSTANT_USEAREA *UseArea, int IsUse, int Index, int Num ) ;				// VF[_[萔gp̈ύX
extern	int		CreateUseAreaMap( SHADERCONSTANT_USEAREA *UseArea, BYTE *Map, BYTE SetNumber ) ;							// VF[_[萔gp̈񂩂gp}bv쐬

extern	int		InitializeShaderConstantInfoSet( SHADERCONSTANTINFOSET *ConstInfoSet ) ;																	// VF[_[萔̏
extern	int		SetUseShaderContantInfoState( SHADERCONSTANTINFOSET *ConstInfoSet, int ApplyMask ) ;														// w̃VF[_[萔ZbgKp邩ǂݒ肷 DX_SHADERCONSTANTSET_MASK_LIB | DX_SHADERCONSTANTSET_MASK_LIB_SUB 
extern	int		SetShaderConstantSet(   SHADERCONSTANTINFOSET *ConstInfoSet, int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea ) ;	// VF[_[萔ݒ肷
extern	int		ResetShaderConstantSet( SHADERCONSTANTINFOSET *ConstInfoSet, int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum ) ;										// ẅ̃VF[_[萔Zbg


}

#endif // __DXGRAPHICS_H__


