#include "DxVertexShaderFxCode.h"

// main֐
VS_OUTPUT main( VS_INPUT VSInput )
{
	VS_OUTPUT VSOutput ;
	int4 lBoneFloatIndex ;
	float4 lLocalWorldMatrix[ 3 ] ;
	float4 lWorldPosition ;
	float4 lViewPosition ;
	float3 lWorldNrm ;
	float3 lWorldTan ;
	float3 lWorldBin ;
	float3 lViewNrm ;
	float3 lViewTan ;
	float3 lViewBin ;
	float3 lBumpTemp ;
	float4 lTotalDiffuse ;
	float4 lTotalSpecular ;
	float3 lLightDir ;
	float lTotalGen ;
	float4 lLightTemp ;
	float lLightDistancePow2 ;
	float lLightGen ;
	float lLightDirectionCosA ;
	float3 lLightHalfVec ;
	float4 lLightLitParam ;
	float4 lLightLitDest ;
	float4 lDifColor;
#if USE_SPE
	float4 lSpeColor;
#endif
#if SHADOWMAP
	float4 lLViewPosition ;
#endif
	
	lDifColor = cfDifSpeSource.x > 0.5f ? VSInput.Diffuse : cfMaterial.Diffuse;
	
#if USE_SPE
	lSpeColor = cfDifSpeSource.y > 0.5f ? VSInput.Specular : cfMaterial.Specular;
#endif

#if ( BUMPMAP == 0 && PHONG ) || SM_3
	VSOutput.Normal_Fog = float4( 0.0f, 0.0f, 0.0f, 1.0f ) ;
#endif

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	#ifdef SKINMESH

		// XLbV

		// uhs̍쐬
		lBoneFloatIndex = VSInput.BlendIndices0 ;
		lLocalWorldMatrix[ 0 ]  = cfLocalWorldMatrix[ lBoneFloatIndex.x + 0 ] * VSInput.BlendWeight0.xxxx;
		lLocalWorldMatrix[ 1 ]  = cfLocalWorldMatrix[ lBoneFloatIndex.x + 1 ] * VSInput.BlendWeight0.xxxx;
		lLocalWorldMatrix[ 2 ]  = cfLocalWorldMatrix[ lBoneFloatIndex.x + 2 ] * VSInput.BlendWeight0.xxxx;

		lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ lBoneFloatIndex.y + 0 ] * VSInput.BlendWeight0.yyyy;
		lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ lBoneFloatIndex.y + 1 ] * VSInput.BlendWeight0.yyyy;
		lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ lBoneFloatIndex.y + 2 ] * VSInput.BlendWeight0.yyyy;

		lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ lBoneFloatIndex.z + 0 ] * VSInput.BlendWeight0.zzzz;
		lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ lBoneFloatIndex.z + 1 ] * VSInput.BlendWeight0.zzzz;
		lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ lBoneFloatIndex.z + 2 ] * VSInput.BlendWeight0.zzzz;

		lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ lBoneFloatIndex.w + 0 ] * VSInput.BlendWeight0.wwww;
		lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ lBoneFloatIndex.w + 1 ] * VSInput.BlendWeight0.wwww;
		lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ lBoneFloatIndex.w + 2 ] * VSInput.BlendWeight0.wwww;

		#ifdef BONE8

			lBoneFloatIndex = VSInput.BlendIndices1 ;
			lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ lBoneFloatIndex.x + 0 ] * VSInput.BlendWeight1.xxxx;
			lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ lBoneFloatIndex.x + 1 ] * VSInput.BlendWeight1.xxxx;
			lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ lBoneFloatIndex.x + 2 ] * VSInput.BlendWeight1.xxxx;

			lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ lBoneFloatIndex.y + 0 ] * VSInput.BlendWeight1.yyyy;
			lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ lBoneFloatIndex.y + 1 ] * VSInput.BlendWeight1.yyyy;
			lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ lBoneFloatIndex.y + 2 ] * VSInput.BlendWeight1.yyyy;

			lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ lBoneFloatIndex.z + 0 ] * VSInput.BlendWeight1.zzzz;
			lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ lBoneFloatIndex.z + 1 ] * VSInput.BlendWeight1.zzzz;
			lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ lBoneFloatIndex.z + 2 ] * VSInput.BlendWeight1.zzzz;

			lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ lBoneFloatIndex.w + 0 ] * VSInput.BlendWeight1.wwww;
			lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ lBoneFloatIndex.w + 1 ] * VSInput.BlendWeight1.wwww;
			lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ lBoneFloatIndex.w + 2 ] * VSInput.BlendWeight1.wwww;

		#endif // BONE8

	#endif	// SKINMESH

	#ifdef TOONOUTLINE

		// WvZ( [J[h )
		lWorldPosition.x = dot( VSInput.Position, LOCAL_WORLD_MAT[ 0 ] ) ;
		lWorldPosition.y = dot( VSInput.Position, LOCAL_WORLD_MAT[ 1 ] ) ;
		lWorldPosition.z = dot( VSInput.Position, LOCAL_WORLD_MAT[ 2 ] ) ;
		lWorldPosition.w = 1.0f ;

		lWorldNrm.x = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
		lWorldNrm.y = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
		lWorldNrm.z = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

		// ֊s̑@Ɉړ
		lWorldPosition.xyz += lWorldNrm * cfToonOutLineSize.x ;

		// [hr[
		lViewPosition.x = dot( lWorldPosition, cfViewMatrix[ 0 ] ) ;
		lViewPosition.y = dot( lWorldPosition, cfViewMatrix[ 1 ] ) ;
		lViewPosition.z = dot( lWorldPosition, cfViewMatrix[ 2 ] ) ;
		lViewPosition.w = 1.0f ;

		// r[vWFNV
		VSOutput.Position.x = dot( lViewPosition, cfProjectionMatrix[ 0 ] ) ;
		VSOutput.Position.y = dot( lViewPosition, cfProjectionMatrix[ 1 ] ) ;
		VSOutput.Position.z = dot( lViewPosition, cfProjectionMatrix[ 2 ] ) ;
		VSOutput.Position.w = dot( lViewPosition, cfProjectionMatrix[ 3 ] ) ;

	#else  // TOONOUTLINE

		// WvZ( [Jr[vWFNV )
		lWorldPosition.x = dot( VSInput.Position, LOCAL_WORLD_MAT[ 0 ] ) ;
		lWorldPosition.y = dot( VSInput.Position, LOCAL_WORLD_MAT[ 1 ] ) ;
		lWorldPosition.z = dot( VSInput.Position, LOCAL_WORLD_MAT[ 2 ] ) ;
		lWorldPosition.w = 1.0f ;

		lViewPosition.x = dot( lWorldPosition, cfViewMatrix[ 0 ] ) ;
		lViewPosition.y = dot( lWorldPosition, cfViewMatrix[ 1 ] ) ;
		lViewPosition.z = dot( lWorldPosition, cfViewMatrix[ 2 ] ) ;
		lViewPosition.w = 1.0f ;

		VSOutput.Position.x = dot( lViewPosition, cfProjectionMatrix[ 0 ] ) ;
		VSOutput.Position.y = dot( lViewPosition, cfProjectionMatrix[ 1 ] ) ;
		VSOutput.Position.z = dot( lViewPosition, cfProjectionMatrix[ 2 ] ) ;
		VSOutput.Position.w = dot( lViewPosition, cfProjectionMatrix[ 3 ] ) ;

	#endif // TOONOUTLINE

	#ifdef BUMPMAP

		// ]@AڐA@r[Ԃɓe
		lWorldTan.x = dot( VSInput.Tan, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
		lWorldTan.y = dot( VSInput.Tan, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
		lWorldTan.z = dot( VSInput.Tan, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

		lWorldBin.x = dot( VSInput.Bin, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
		lWorldBin.y = dot( VSInput.Bin, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
		lWorldBin.z = dot( VSInput.Bin, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

		lWorldNrm.x = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
		lWorldNrm.y = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
		lWorldNrm.z = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

		lViewTan.x = dot( lWorldTan, cfViewMatrix[ 0 ].xyz ) ;
		lViewTan.y = dot( lWorldTan, cfViewMatrix[ 1 ].xyz ) ;
		lViewTan.z = dot( lWorldTan, cfViewMatrix[ 2 ].xyz ) ;

		lViewBin.x = dot( lWorldBin, cfViewMatrix[ 0 ].xyz ) ;
		lViewBin.y = dot( lWorldBin, cfViewMatrix[ 1 ].xyz ) ;
		lViewBin.z = dot( lWorldBin, cfViewMatrix[ 2 ].xyz ) ;

		lViewNrm.x = dot( lWorldNrm, cfViewMatrix[ 0 ].xyz ) ;
		lViewNrm.y = dot( lWorldNrm, cfViewMatrix[ 1 ].xyz ) ;
		lViewNrm.z = dot( lWorldNrm, cfViewMatrix[ 2 ].xyz ) ;

	#endif	// BUMPMAP


	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )

	#if LG_USE == 0 || BUMPMAP == 1 || PHONG == 1

		// CggpȂAov}bv̓tHVF[fBȌꍇ̓}eA( or _ )J[̂܂܏o
		VSOutput.Diffuse  = lDifColor ;

		#if USE_SPE
			VSOutput.Specular = lSpeColor ;
		#endif

	#endif // LG_USE == 0 || BUMPMAP == 1 || PHONG == 1





	// Cg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
	#if LG_USE

		#ifdef BUMPMAP

			#if USE_SPE
				// _W王_ւ̃xNgڒԂɓe㐳Kĕۑ
				lBumpTemp.x = dot( lViewTan, -lViewPosition.xyz ) ;
				lBumpTemp.y = dot( lViewBin, -lViewPosition.xyz ) ;
				lBumpTemp.z = dot( lViewNrm, -lViewPosition.xyz ) ;
				VSOutput.V_to_Eye = normalize( lBumpTemp ) ;
			#endif

		#else // BUMPMAP 

			// @r[Ԃ̊pxɕϊ( LOCAL_WORLD_MAT ̓XLjObV ̏ꍇ r0 ĝ mov r0, ZERO ɎsKv )
			lWorldNrm.x = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
			lWorldNrm.y = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
			lWorldNrm.z = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

			lViewNrm.x = dot( lWorldNrm, cfViewMatrix[ 0 ].xyz ) ;
			lViewNrm.y = dot( lWorldNrm, cfViewMatrix[ 1 ].xyz ) ;
			lViewNrm.z = dot( lWorldNrm, cfViewMatrix[ 2 ].xyz ) ;

			// fBt[YJ[ƃXyLJ[̒~ϒl̏
			lTotalDiffuse = float4( 0, 0, 0, 0 ) ;
			lTotalSpecular = float4( 0, 0, 0, 0 ) ;

			#ifdef PHONG

				#if USE_SPE
					// _W王_ւ̃xNg𐳋Kĕۑ
					VSOutput.V_to_Eye = normalize( -lViewPosition.xyz ) ;
				#endif

				// @ۑ
				VSOutput.Normal_Fog.xyz = lViewNrm ;

			#endif // PHONG

		#endif // BUMPMAP







		// Cg0̏ ***********************************************************************************************************************************( Jn )
#if LG0_USE

	#ifdef ALL_VS
		if( cbLightBool[ 0 ].Use )
		{
	#endif

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( Jn )

	#if LG0_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 0 ].Direction ;

	#else  // LG0_DIR

		// CgxNǧvZ
		lLightDir = normalize( lViewPosition.xyz - cfLight[ 0 ].Position.xyz ) ;

	#endif  // LG0_DIR

	// Cg̏
	VSOutput.Light0_Dir_Gen = ZERO ;

	// Cǧ̋txNgڒnԂɕϊ
	#ifdef BUMPMAP

		VSOutput.Light0_Dir_Gen.x = dot( lViewTan, -lLightDir ) ;
		VSOutput.Light0_Dir_Gen.y = dot( lViewBin, -lLightDir ) ;
		VSOutput.Light0_Dir_Gen.z = dot( lViewNrm, -lLightDir ) ;

	#elif PHONG // BUMPMAP

		// Cǧ̋txNgۑ
		VSOutput.Light0_Dir_Gen.xyz = -lLightDir ;

	#endif // BUMPMAP

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( I )


	// EX|bgCglvZ ==========================( Jn )
	#if LG0_SPOT || LG0_POINT

		#ifdef ALL_VS
			lTotalGen = 1.0f;
			if( cbLightBool[ 0 ].Point_Or_Spot )
			{
		#endif // ALL_VS

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂ lLightTemp.x = ( POS - L0_POS ) * ( POS - L0_POS )
		lLightTemp = lViewPosition - cfLight[ 0 ].Position ;
		lLightTemp.w = 0.0f;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = 1.0f / ( cfLight[ 0 ].Range_FallOff_AT0_AT1.z + cfLight[ 0 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 0 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// X|bgCgvZ --------

		#if LG0_SPOT

			#ifdef ALL_VS
				if( cbLightBool[ 0 ].Spot )
				{
			#endif // ALL_VS

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 0 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 0 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 0 ].AT2_SpotP0_SpotP1.z ), cfLight[ 0 ].Range_FallOff_AT0_AT1.y ) ) ;

			#ifdef ALL_VS
				} // if( cbLightBool[ 0 ].Spot )
			#endif

		#endif // LG0_SPOT

		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 0 ].Range_FallOff_AT0_AT1.x ) ;

		// ov}bv or tHVF[fBOpɌۑ
		#if PHONG || BUMPMAP
			VSOutput.Light0_Dir_Gen.w = lLightGen ;
		#endif // PHONG || BUMPMAP

		#ifdef ALL_VS
			} // if( cbLightBool[ 0 ].Point_Or_Spot )
		#endif

	#endif // LG0_SPOT || LG0_POINT
	// EX|bgCglvZ =========================( I )




	// fBt[YCgƃXyLCg̊pxvZ =======( Jn )
	#if BUMPMAP == 0 && PHONG == 0

		// @ƃCg̋txNgƂ̓ς lLightLitParam.x ɃZbg
		lLightLitParam.x = dot( lViewNrm, -lLightDir ) ;

		#ifdef USE_SPE

			// n[txNǧvZ norm( ( norm( _ʒu王_ւ̃xNg ) + Cg̕ ) )
			lLightHalfVec = normalize( normalize( -lViewPosition.xyz ) - lLightDir ) ;

			// @ƃn[txNg̓ς lLightLitParam.y ɃZbg
			lLightLitParam.y = dot( lLightHalfVec, lViewNrm ) ;

			// XyL˗ lLightLitParam.w ɃZbg
			lLightLitParam.w = cfMaterial.Power.x ;

			// CgvZ
			lLightLitDest = lit( lLightLitParam.x, lLightLitParam.y, lLightLitParam.w ) ;

		#else // USE_SPE

			lLightLitDest.y = max( lLightLitParam.x, 0.0f ) ;

		#endif // USE_SPE

	#endif // BUMPMAP == 0 && PHONG == 0
	// fBt[YCgƃXyLCg̊pxvZ =======( I )





	// fBt[YJ[vZ =======================================( Jn )

	#if BUMPMAP == 0 && PHONG == 0

		#if LG0_SPOT || LG0_POINT

			// fBt[YCg~ϒl += EX|bgCgpxl * ( fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z )
			lTotalDiffuse += lLightGen * ( lLightLitDest.y * cfLight[ 0 ].Diffuse * lDifColor + cfLight[ 0 ].Ambient ) ;

		#else  // LG0_SPOT || LG0_POINT

			// fBt[YCg~ϒl += fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z
			lTotalDiffuse += lLightLitDest.y * cfLight[ 0 ].Diffuse * lDifColor + cfLight[ 0 ].Ambient ;

		#endif // LG0_SPOT || LG0_POINT

	#endif // BUMPMAP == 0 && PHONG == 0

	// fBt[YJ[vZ =======================================( I )





	// XyLJ[vZ =======================================( Jn )

	#ifdef USE_SPE

		#if BUMPMAP == 0 && PHONG == 0

			#if LG0_SPOT || LG0_POINT || ALL_VS

				// XyLCg~ϒl += XyLpxvZ * EX|bgCg * Cg̃XyLJ[
				lTotalSpecular += lLightGen * lLightLitDest.z * cfLight[ 0 ].Specular ;

			#else	// LG0_SPOT || LG0_POINT || ALL_VS

				// XyLCg~ϒl += XyLpxvZ * Cg̃XyLJ[
				lTotalSpecular += lLightLitDest.z * cfLight[ 0 ].Specular ;

			#endif	// LG0_SPOT || LG0_POINT || ALL_VS

		#endif // BUMPMAP == 0 && PHONG == 0

	#endif // USE_SPE

	// XyLJ[vZ =======================================( I )




	#ifdef ALL_VS
		} // if( cbLightBool[ 0 ].Use )
	#endif

#endif  // LG0_USE
// Cg0̏ ***********************************************************************************************************************************( I )








		// Cg1̏ ***********************************************************************************************************************************( Jn )
#if LG1_USE

	#ifdef ALL_VS
		if( cbLightBool[ 1 ].Use )
		{
	#endif

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( Jn )

	#if LG1_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 1 ].Direction ;

	#else  // LG1_DIR

		// CgxNǧvZ
		lLightDir = normalize( lViewPosition.xyz - cfLight[ 1 ].Position.xyz ) ;

	#endif  // LG1_DIR

	// Cg̏
	VSOutput.Light1_Dir_Gen = ZERO ;

	// Cǧ̋txNgڒnԂɕϊ
	#ifdef BUMPMAP

		VSOutput.Light1_Dir_Gen.x = dot( lViewTan, -lLightDir ) ;
		VSOutput.Light1_Dir_Gen.y = dot( lViewBin, -lLightDir ) ;
		VSOutput.Light1_Dir_Gen.z = dot( lViewNrm, -lLightDir ) ;

	#elif PHONG // BUMPMAP

		// Cǧ̋txNgۑ
		VSOutput.Light1_Dir_Gen.xyz = -lLightDir ;

	#endif // BUMPMAP

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( I )


	// EX|bgCglvZ ==========================( Jn )
	#if LG1_SPOT || LG1_POINT

		#ifdef ALL_VS
			lTotalGen = 1.0f;
			if( cbLightBool[ 1 ].Point_Or_Spot )
			{
		#endif // ALL_VS

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂ lLightTemp.x = ( POS - L1_POS ) * ( POS - L1_POS )
		lLightTemp = lViewPosition - cfLight[ 1 ].Position ;
		lLightTemp.w = 0.0f;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = 1.0f / ( cfLight[ 1 ].Range_FallOff_AT0_AT1.z + cfLight[ 1 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 1 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// X|bgCgvZ --------

		#if LG1_SPOT

			#ifdef ALL_VS
				if( cbLightBool[ 1 ].Spot )
				{
			#endif // ALL_VS

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 1 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 1 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 1 ].AT2_SpotP0_SpotP1.z ), cfLight[ 1 ].Range_FallOff_AT0_AT1.y ) ) ;

			#ifdef ALL_VS
				} // if( cbLightBool[ 1 ].Spot )
			#endif

		#endif // LG1_SPOT

		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 1 ].Range_FallOff_AT0_AT1.x ) ;

		// ov}bv or tHVF[fBOpɌۑ
		#if PHONG || BUMPMAP
			VSOutput.Light1_Dir_Gen.w = lLightGen ;
		#endif // PHONG || BUMPMAP

		#ifdef ALL_VS
			} // if( cbLightBool[ 1 ].Point_Or_Spot )
		#endif

	#endif // LG1_SPOT || LG1_POINT
	// EX|bgCglvZ =========================( I )




	// fBt[YCgƃXyLCg̊pxvZ =======( Jn )
	#if BUMPMAP == 0 && PHONG == 0

		// @ƃCg̋txNgƂ̓ς lLightLitParam.x ɃZbg
		lLightLitParam.x = dot( lViewNrm, -lLightDir ) ;

		#ifdef USE_SPE

			// n[txNǧvZ norm( ( norm( _ʒu王_ւ̃xNg ) + Cg̕ ) )
			lLightHalfVec = normalize( normalize( -lViewPosition.xyz ) - lLightDir ) ;

			// @ƃn[txNg̓ς lLightLitParam.y ɃZbg
			lLightLitParam.y = dot( lLightHalfVec, lViewNrm ) ;

			// XyL˗ lLightLitParam.w ɃZbg
			lLightLitParam.w = cfMaterial.Power.x ;

			// CgvZ
			lLightLitDest = lit( lLightLitParam.x, lLightLitParam.y, lLightLitParam.w ) ;

		#else // USE_SPE

			lLightLitDest.y = max( lLightLitParam.x, 0.0f ) ;

		#endif // USE_SPE

	#endif // BUMPMAP == 0 && PHONG == 0
	// fBt[YCgƃXyLCg̊pxvZ =======( I )





	// fBt[YJ[vZ =======================================( Jn )

	#if BUMPMAP == 0 && PHONG == 0

		#if LG1_SPOT || LG1_POINT

			// fBt[YCg~ϒl += EX|bgCgpxl * ( fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z )
			lTotalDiffuse += lLightGen * ( lLightLitDest.y * cfLight[ 1 ].Diffuse * lDifColor + cfLight[ 1 ].Ambient ) ;

		#else  // LG1_SPOT || LG1_POINT

			// fBt[YCg~ϒl += fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z
			lTotalDiffuse += lLightLitDest.y * cfLight[ 1 ].Diffuse * lDifColor + cfLight[ 1 ].Ambient ;

		#endif // LG1_SPOT || LG1_POINT

	#endif // BUMPMAP == 0 && PHONG == 0

	// fBt[YJ[vZ =======================================( I )





	// XyLJ[vZ =======================================( Jn )

	#ifdef USE_SPE

		#if BUMPMAP == 0 && PHONG == 0

			#if LG1_SPOT || LG1_POINT || ALL_VS

				// XyLCg~ϒl += XyLpxvZ * EX|bgCg * Cg̃XyLJ[
				lTotalSpecular += lLightGen * lLightLitDest.z * cfLight[ 1 ].Specular ;

			#else	// LG1_SPOT || LG1_POINT || ALL_VS

				// XyLCg~ϒl += XyLpxvZ * Cg̃XyLJ[
				lTotalSpecular += lLightLitDest.z * cfLight[ 1 ].Specular ;

			#endif	// LG1_SPOT || LG1_POINT || ALL_VS

		#endif // BUMPMAP == 0 && PHONG == 0

	#endif // USE_SPE

	// XyLJ[vZ =======================================( I )




	#ifdef ALL_VS
		} // if( cbLightBool[ 1 ].Use )
	#endif

#endif  // LG1_USE
// Cg1̏ ***********************************************************************************************************************************( I )








		// Cg2̏ ***********************************************************************************************************************************( Jn )
#if LG2_USE

	#ifdef ALL_VS
		if( cbLightBool[ 2 ].Use )
		{
	#endif

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( Jn )

	#if LG2_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 2 ].Direction ;

	#else  // LG2_DIR

		// CgxNǧvZ
		lLightDir = normalize( lViewPosition.xyz - cfLight[ 2 ].Position.xyz ) ;

	#endif  // LG2_DIR

	// Cg̏
	VSOutput.Light2_Dir_Gen = ZERO ;

	// Cǧ̋txNgڒnԂɕϊ
	#ifdef BUMPMAP

		VSOutput.Light2_Dir_Gen.x = dot( lViewTan, -lLightDir ) ;
		VSOutput.Light2_Dir_Gen.y = dot( lViewBin, -lLightDir ) ;
		VSOutput.Light2_Dir_Gen.z = dot( lViewNrm, -lLightDir ) ;

	#elif PHONG // BUMPMAP

		// Cǧ̋txNgۑ
		VSOutput.Light2_Dir_Gen.xyz = -lLightDir ;

	#endif // BUMPMAP

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( I )


	// EX|bgCglvZ ==========================( Jn )
	#if LG2_SPOT || LG2_POINT

		#ifdef ALL_VS
			lTotalGen = 1.0f;
			if( cbLightBool[ 2 ].Point_Or_Spot )
			{
		#endif // ALL_VS

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂ lLightTemp.x = ( POS - L2_POS ) * ( POS - L2_POS )
		lLightTemp = lViewPosition - cfLight[ 2 ].Position ;
		lLightTemp.w = 0.0f;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = 1.0f / ( cfLight[ 2 ].Range_FallOff_AT0_AT1.z + cfLight[ 2 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 2 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// X|bgCgvZ --------

		#if LG2_SPOT

			#ifdef ALL_VS
				if( cbLightBool[ 2 ].Spot )
				{
			#endif // ALL_VS

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 2 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 2 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 2 ].AT2_SpotP0_SpotP1.z ), cfLight[ 2 ].Range_FallOff_AT0_AT1.y ) ) ;

			#ifdef ALL_VS
				} // if( cbLightBool[ 2 ].Spot )
			#endif

		#endif // LG2_SPOT

		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 2 ].Range_FallOff_AT0_AT1.x ) ;

		// ov}bv or tHVF[fBOpɌۑ
		#if PHONG || BUMPMAP
			VSOutput.Light2_Dir_Gen.w = lLightGen ;
		#endif // PHONG || BUMPMAP

		#ifdef ALL_VS
			} // if( cbLightBool[ 2 ].Point_Or_Spot )
		#endif

	#endif // LG2_SPOT || LG2_POINT
	// EX|bgCglvZ =========================( I )




	// fBt[YCgƃXyLCg̊pxvZ =======( Jn )
	#if BUMPMAP == 0 && PHONG == 0

		// @ƃCg̋txNgƂ̓ς lLightLitParam.x ɃZbg
		lLightLitParam.x = dot( lViewNrm, -lLightDir ) ;

		#ifdef USE_SPE

			// n[txNǧvZ norm( ( norm( _ʒu王_ւ̃xNg ) + Cg̕ ) )
			lLightHalfVec = normalize( normalize( -lViewPosition.xyz ) - lLightDir ) ;

			// @ƃn[txNg̓ς lLightLitParam.y ɃZbg
			lLightLitParam.y = dot( lLightHalfVec, lViewNrm ) ;

			// XyL˗ lLightLitParam.w ɃZbg
			lLightLitParam.w = cfMaterial.Power.x ;

			// CgvZ
			lLightLitDest = lit( lLightLitParam.x, lLightLitParam.y, lLightLitParam.w ) ;

		#else // USE_SPE

			lLightLitDest.y = max( lLightLitParam.x, 0.0f ) ;

		#endif // USE_SPE

	#endif // BUMPMAP == 0 && PHONG == 0
	// fBt[YCgƃXyLCg̊pxvZ =======( I )





	// fBt[YJ[vZ =======================================( Jn )

	#if BUMPMAP == 0 && PHONG == 0

		#if LG2_SPOT || LG2_POINT

			// fBt[YCg~ϒl += EX|bgCgpxl * ( fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z )
			lTotalDiffuse += lLightGen * ( lLightLitDest.y * cfLight[ 2 ].Diffuse * lDifColor + cfLight[ 2 ].Ambient ) ;

		#else  // LG2_SPOT || LG2_POINT

			// fBt[YCg~ϒl += fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z
			lTotalDiffuse += lLightLitDest.y * cfLight[ 2 ].Diffuse * lDifColor + cfLight[ 2 ].Ambient ;

		#endif // LG2_SPOT || LG2_POINT

	#endif // BUMPMAP == 0 && PHONG == 0

	// fBt[YJ[vZ =======================================( I )





	// XyLJ[vZ =======================================( Jn )

	#ifdef USE_SPE

		#if BUMPMAP == 0 && PHONG == 0

			#if LG2_SPOT || LG2_POINT || ALL_VS

				// XyLCg~ϒl += XyLpxvZ * EX|bgCg * Cg̃XyLJ[
				lTotalSpecular += lLightGen * lLightLitDest.z * cfLight[ 2 ].Specular ;

			#else	// LG2_SPOT || LG2_POINT || ALL_VS

				// XyLCg~ϒl += XyLpxvZ * Cg̃XyLJ[
				lTotalSpecular += lLightLitDest.z * cfLight[ 2 ].Specular ;

			#endif	// LG2_SPOT || LG2_POINT || ALL_VS

		#endif // BUMPMAP == 0 && PHONG == 0

	#endif // USE_SPE

	// XyLJ[vZ =======================================( I )




	#ifdef ALL_VS
		} // if( cbLightBool[ 2 ].Use )
	#endif

#endif  // LG2_USE
// Cg2̏ ***********************************************************************************************************************************( I )















		// SẴfBt[Yvf킹ďo̓WX^ɃZbg =====( Jn )

		#if BUMPMAP == 0 && PHONG == 0

			// o̓fBt[YJ[ = CgfBt[YJ[~ϒl + ( }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z )
			VSOutput.Diffuse = lTotalDiffuse + cfAmbient_Emissive ;

			// At@̓fBt[YJ[̃At@̂܂܎g
			VSOutput.Diffuse.w = lDifColor.w ;

		#endif // BUMPMAP == 0 && PHONG == 0

		// SẴfBt[Yvf킹ďo̓WX^ɃZbg =====( I )





		// SẴXyLvf킹ďo̓WX^ɃZbg =====( Jn )

		#if USE_SPE && BUMPMAP == 0 && PHONG == 0

			// o̓XyLJ[ = CgXyLJ[~ϒl * XyLJ[
			VSOutput.Specular = lTotalSpecular * lSpeColor ;

		#endif // USE_SPE && BUMPMAP == 0 && PHONG == 0

		// SẴXyLvf킹ďo̓WX^ɃZbg =====( I )






	#endif // LG_USE
	// Cg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )















	// tHOvZ =============================================( Jn )

	#if FOG_LINEAR || FOG_EXP || FOG_EXP2

		#ifdef FOG_LINEAR

			// `tHOvZ
			FOG_OUT = lViewPosition.z * FOG_LINEAR_DIV + FOG_LINEAR_ADD ;

		#endif

		#ifdef FOG_EXP

			// wtHOvZ 1.0f / pow( e,  * density )
			FOG_OUT = 1.0f / pow( abs( FOG_EXP_E ), lViewPosition.z * FOG_EXP_DENSITY ) ;

		#endif

		#ifdef FOG_EXP2

			// wtHOQvZ 1.0f / pow( e, (  * density ) * (  * density ) )
			FOG_OUT = 1.0f / pow( abs( FOG_EXP_E ), ( lViewPosition.z * FOG_EXP_DENSITY ) * ( lViewPosition.z * FOG_EXP_DENSITY ) ) ;

		#endif

	#endif // FOG_LINEAR || FOG_EXP || FOG_EXP2

	// tHOvZ =============================================( I )

#if SHADOWMAP_DRAW
	// ˉeWeNX`WƂďo͂ =================( Jn )

	VSOutput.ShadowMap1Pos.xyz = VSOutput.Position.xyz ;

	// ˉeWeNX`WƂďo͂ =================( I )
#endif


#if SHADOWMAP
	// [xep̃Cg猩ˉeWZo =================( Jn )

	// [hWCg̃r[Wɕϊ
	lLViewPosition.x = dot( lWorldPosition, cfShadowMap1LightViewMatrix[ 0 ] ) ;
	lLViewPosition.y = dot( lWorldPosition, cfShadowMap1LightViewMatrix[ 1 ] ) ;
	lLViewPosition.z = dot( lWorldPosition, cfShadowMap1LightViewMatrix[ 2 ] ) ;
	lLViewPosition.w = 1.0f ;

	// Cg̃r[WCg̎ˉeWɕϊ
	VSOutput.ShadowMap1Pos.x = dot( lLViewPosition, cfShadowMap1LightProjectionMatrix[ 0 ] ) ;
	VSOutput.ShadowMap1Pos.y = dot( lLViewPosition, cfShadowMap1LightProjectionMatrix[ 1 ] ) ;
	VSOutput.ShadowMap1Pos.z = dot( lLViewPosition, cfShadowMap1LightProjectionMatrix[ 2 ] ) ;

	// [hWCg̃r[Wɕϊ
	lLViewPosition.x = dot( lWorldPosition, cfShadowMap2LightViewMatrix[ 0 ] ) ;
	lLViewPosition.y = dot( lWorldPosition, cfShadowMap2LightViewMatrix[ 1 ] ) ;
	lLViewPosition.z = dot( lWorldPosition, cfShadowMap2LightViewMatrix[ 2 ] ) ;
	lLViewPosition.w = 1.0f ;

	// Cg̃r[WCg̎ˉeWɕϊ
	VSOutput.ShadowMap2Pos.x = dot( lLViewPosition, cfShadowMap2LightProjectionMatrix[ 0 ] ) ;
	VSOutput.ShadowMap2Pos.y = dot( lLViewPosition, cfShadowMap2LightProjectionMatrix[ 1 ] ) ;
	VSOutput.ShadowMap2Pos.z = dot( lLViewPosition, cfShadowMap2LightProjectionMatrix[ 2 ] ) ;

	// [xep̃Cg猩ˉeWZo =================( I )
#endif

	// eNX`W̃Zbg
	VSOutput.TexCoords0_1.x = dot( VSInput.TexCoords0, cfTextureMatrix[ 0 ][ 0 ] ) ;
	VSOutput.TexCoords0_1.y = dot( VSInput.TexCoords0, cfTextureMatrix[ 0 ][ 1 ] ) ;

//#ifdef SUBTEXTURE
	VSOutput.TexCoords0_1.z = dot( VSInput.TexCoords1, cfTextureMatrix[ 0 ][ 0 ] ) ;
	VSOutput.TexCoords0_1.w = dot( VSInput.TexCoords1, cfTextureMatrix[ 0 ][ 1 ] ) ;
//#endif // SUBTEXTURE


	return VSOutput ;
}

